=== modified file '.bzrignore'
--- .bzrignore	2008-10-03 09:32:30 +0000
+++ .bzrignore	2008-09-06 16:33:54 +0000
@@ -1,14 +1,8 @@
 *.5
 *.8
 *.8mandos
+plugin-runner
+plugins.d/password-prompt
+plugins.d/mandos-client
 confdir
-debian/po/messages.mo
-debian/po/templates.pot
 keydir
-man
-plugin-runner
-plugins.d/askpass-fifo
-plugins.d/mandos-client
-plugins.d/password-prompt
-plugins.d/splashy
-plugins.d/usplash

=== modified file 'INSTALL'
--- INSTALL	2008-10-28 18:00:20 +0000
+++ INSTALL	2008-09-08 18:54:47 +0000
@@ -97,28 +97,10 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
-     file must be updated, possibly using the following command:
-     
-	# update-initramfs -k all -u
-  
-  5. On the server computer, start the server by running the command
+  4. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
      For Ubuntu: sudo invoke-rc.d mandos start
      
-     At this point, it is possible to verify that the correct password
-     will be received by the client by running the command:
-     
-	# /usr/lib/mandos/plugins.d/mandos-client \
-		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt; echo
-     
-     This command should retrieve the password from the server,
-     decrypt it, and output it to standard output.
-     
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
      take more than an hour to reboot.
@@ -127,6 +109,6 @@
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used, it is suggested that a more cryptographically
+  Is IPsec is not used, it is suggested that a more cryptographically
   secure checker program is used and configured, since without IPsec
   ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2008-10-28 18:00:20 +0000
+++ Makefile	2008-09-17 00:34:09 +0000
@@ -9,14 +9,10 @@
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIE -pie
-LINK_FORTIFY=-z relro -pie
+FORTIFY=-D_FORTIFY_SOURCE=2 # -fstack-protector-all
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
-htmldir=man
-version=1.0.2
-SED=sed
 
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
@@ -43,9 +39,8 @@
 
 # Do not change these two
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
-	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
-	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY)
+	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS)
+LDFLAGS=$(COVERAGE)
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
@@ -58,136 +53,64 @@
 	$(notdir $<); \
 	$(MANPOST) $(notdir $@)
 # DocBook-to-man post-processing to fix a '\n' escape bug
-MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
-
-DOCBOOKTOHTML=xsltproc --nonet --xinclude \
-	--param make.year.ranges		1 \
-	--param make.single.year.ranges		1 \
-	--param man.output.quietly		1 \
-	--param man.authors.section.enabled	0 \
-	--param citerefentry.link		1 \
-	--output $@ \
-	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
-	$<; $(HTMLPOST) $@
-# Fix citerefentry links
-HTMLPOST=$(SED) --in-place \
-	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
-
-PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
-	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
-CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen $(CPROGS)
+MANPOST=sed --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
+
+PLUGINS=plugins.d/password-prompt plugins.d/mandos-client
+PROGS=plugin-runner $(PLUGINS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
-	plugins.d/usplash.8mandos plugins.d/splashy.8mandos \
-	plugins.d/askpass-fifo.8mandos mandos-clients.conf.5
-
-htmldocs=$(addsuffix .xhtml,$(DOCS))
-
-objects=$(addsuffix .o,$(CPROGS))
-
-all: $(PROGS) mandos.lsm
+	mandos-clients.conf.5
+
+objects=$(addsuffix .o,$(PROGS))
+
+all: $(PROGS)
 
 doc: $(DOCS)
 
-html: $(htmldocs)
-
-%.5: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.5.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-%.8: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.8.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-%.8mandos: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOMAN)
-%.8mandos.xhtml: %.xml common.ent legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
-		overview.xml legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
-		 legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
-		legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
-		legalnotice.xml
-	$(DOCBOOKTOMAN)
-plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
-		overview.xml legalnotice.xml
-	$(DOCBOOKTOHTML)
+%.5: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+%.8: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+%.8mandos: %.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+mandos.8: mandos.xml mandos-options.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+mandos-keygen.8: mandos-keygen.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+mandos.conf.5: mandos.conf.xml mandos-options.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+
+plugin-runner.8mandos: plugin-runner.xml overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
 
 plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
-					common.ent \
 					mandos-options.xml \
 					overview.xml legalnotice.xml
 	$(DOCBOOKTOMAN)
-plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
-					common.ent \
-					mandos-options.xml \
-					overview.xml legalnotice.xml
-	$(DOCBOOKTOHTML)
-
-# Update all these files with version number $(version)
-common.ent: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(<ENTITY VERSION "\)[^"]*">$$/\1$(version)"/' \
-		$@
-
-mandos: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos-keygen: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@
-
-mandos.lsm: Makefile
-	$(SED) --in-place \
-		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@
-	$(SED) --in-place \
-		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@
 
 plugins.d/mandos-client: plugins.d/mandos-client.o
 	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
 		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
-.PHONY : all doc html clean distclean run-client run-server install \
+.PHONY : all doc clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \
 	uninstall-client purge purge-server purge-client
 
 clean:
-	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
+	-rm --force $(PROGS) $(objects) $(DOCS) core
 
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
 	-rm --force --recursive keydir confdir
 
-check:	all
+check:
 	./mandos --check
 
 # Run the client with a local config and key
@@ -217,11 +140,6 @@
 
 install: install-server install-client-nokey
 
-install-html: html
-	install --directory $(htmldir)
-	install --mode=u=rw,go=r --target-directory=$(htmldir) \
-		$(htmldocs)
-
 install-server: doc
 	install --directory $(CONFDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
@@ -233,9 +151,7 @@
 		$(DESTDIR)/etc/init.d/mandos
 	install --mode=u=rw,go=r default-mandos \
 		$(DESTDIR)/etc/default/mandos
-	if [ -z $(DESTDIR) ]; then \
-		update-rc.d mandos defaults 25 15;\
-	fi
+	update-rc.d mandos defaults
 	gzip --best --to-stdout mandos.8 \
 		> $(MANDIR)/man8/mandos.8.gz
 	gzip --best --to-stdout mandos.conf.5 \
@@ -249,7 +165,9 @@
 		$(PREFIX)/lib/mandos/plugins.d
 	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
 		install --mode=u=rwx \
-			--directory "$(CONFDIR)/plugins.d"; \
+			--directory "$(CONFDIR)/plugins.d" && \
+		install --mode=u=rw,go=r etc-plugins.d-README \
+			$(CONFDIR)/plugins.d/README ; \
 	fi
 	install --mode=u=rwx,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos plugin-runner
@@ -261,15 +179,9 @@
 	install --mode=u=rwxs,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/mandos-client
-	install --mode=u=rwxs,go=rx \
+	install --mode=u=rwx,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/usplash
-	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
-		plugins.d/splashy
-	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
-		plugins.d/askpass-fifo
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \
@@ -285,12 +197,6 @@
 		> $(MANDIR)/man8/password-prompt.8mandos.gz
 	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
 		> $(MANDIR)/man8/mandos-client.8mandos.gz
-	gzip --best --to-stdout plugins.d/usplash.8mandos \
-		> $(MANDIR)/man8/usplash.8mandos.gz
-	gzip --best --to-stdout plugins.d/splashy.8mandos \
-		> $(MANDIR)/man8/splashy.8mandos.gz
-	gzip --best --to-stdout plugins.d/askpass-fifo.8mandos \
-		> $(MANDIR)/man8/askpass-fifo.8mandos.gz
 
 install-client: install-client-nokey
 # Post-installation stuff
@@ -318,18 +224,16 @@
 		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
 		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
 		$(PREFIX)/lib/mandos/plugins.d/usplash \
-		$(PREFIX)/lib/mandos/plugins.d/splashy \
-		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/local-top/mandos \
 		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
 		$(MANDIR)/man8/password-prompt.8mandos.gz \
-		$(MANDIR)/man8/usplash.8mandos.gz \
-		$(MANDIR)/man8/splashy.8mandos.gz \
-		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/mandos-client.8mandos.gz
+	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
+		rm --force $(CONFDIR)/plugins.d/README; \
+	fi
 	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
 		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u

=== removed file 'NEWS'
--- NEWS	2008-10-17 18:56:25 +0000
+++ NEWS	1970-01-01 00:00:00 +0000
@@ -1,23 +0,0 @@
-This NEWS file records noteworthy changes, very tersely.
-See the manual for detailed information.
-
-Version 1.0.2 (2008-10-17)
-* mandos-keygen now signs the encrypted key blobs.  This signature is
-  not currently verified by mandos-client, but this may change in the
-  future.
-
-Version 1.0.1 (2008-10-07)
-* Server
-** Expand environment variables and ~user in clients.conf's "secfile"
-   The "secfile" option in /etc/mandos/clients.conf now expands
-   "~user/foo" and "$ENVVAR" strings.
-
-* Client (plugin-runner, plugins, etc.)
-** Manual pages for the usplash, splashy, and askpass-fifo plugins.
-   All plugins now have man pages.
-** More secure compilation and linking flags.
-   All programs are now compiled with "-fstack-protector-all -fPIE
-   -pie", and linked using "-z relro -pie" for additional security.
-
-* There is now a "NEWS" file (this one), giving a history of
-  noteworthy changes.

=== modified file 'README'
--- README	2008-10-28 18:00:20 +0000
+++ README	2008-09-17 00:34:09 +0000
@@ -130,38 +130,10 @@
   on your door and the sudden absence of all the servers in your
   server room.  Which it does nicely.
 
-* The Plugin System
-  In the early designs, the mandos-client(8mandos) program (which
-  retrieves a password from the Mandos server) also prompted for a
-  password on the terminal, in case a Mandos server could not be
-  found.  This duality of purpose was seen to be too complex to be a
-  viable way to continue.  Instead, the programs are now separated
-  into mandos-client(8mandos) and password-prompt(8mandos), and a
-  plugin-runner(8mandos) exist to run them both in parallel, allowing
-  the first plugin to succeed to provide the password.  This opened up
-  for any number of additional plugins to run, all competing to be the
-  first to find a password and provide it to the plugin runner.
-  
-  Three additional plugins are provided:
-  * usplash(8mandos)
-    This prompts for a password when using usplash(8).
-  * splashy(8mandos)
-    This prompts for a password when using splashy(8).
-  * askpass-fifo(8mandos)
-    To provide compatibility with the "askpass" program from
-    cryptsetup, this plugin listens to the same FIFO as askpass would
-    do.
-  
-  (None of these take any options or reads any files.)
-  
-  More plugins could easily be written and added by the system
-  administrator; see the section called "WRITING PLUGINS" in
-  plugin-runner(8mandos) to learn the plugin requirements.
-
 * Copyright
 
     Copyright © 2008 Teddy Hogeborn
-    Copyright © 2008 Björn Påhlsson
+                2008 Björn Påhlsson
   
 ** License:
    

=== modified file 'TODO'
--- TODO	2008-11-11 16:07:18 +0000
+++ TODO	2008-09-19 12:02:03 +0000
@@ -1,11 +1,16 @@
 -*- org -*-
 
+* plugin-runner
+** TODO Man page  for plugin-runner.conf.5
+   link to plugin-runner.8
+
 * mandos-client
 ** TODO [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
-   klogctl(6, NULL, 0); klogctl(7, NULL, 0);
 ** TODO [#C] IPv4 support
 
+* DONE password-prompt
+
 * mandos (server)
 ** TODO [#B] Log level				:bugs:
 ** TODO /etc/mandos/clients.d/*.conf
@@ -14,23 +19,6 @@
 ** TODO [#B] Run-time communication with server :bugs:
    Probably using D-Bus
    See also [[*Mandos-tools]]
-*** Client class
-    Remove unneeded Get* methods?
-*** Main server
-    + Clients
-      out_signature="ao"
-      Does this have to be "GetClients" so as not to collide with the
-      interface name?
-    + SetLogLevel
-      syslogger.setLevel(logging.WARNING)
-    + Quit
-    + GetClientsProperties "aa{sv}":
-      dbus.Array(dbus.Dictionary({dbus.String("name"):
-                                  dbus.String("foo", variant_level=1),
-                                  dbus.String("created"):
-				  dbus.Array(dbus.Int16(2008), ...,
-                                             variant_level=1)}))
-    + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
 ** TODO Implement --foreground			:bugs:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
@@ -38,8 +26,6 @@
 ** TODO Date+time on console log messages	:bugs:
    Is this the default?
 ** TODO delete hook when clients fall out by timeout
-   This will not be strictly necessary when the D-Bus interface is
-   implemented.
 
 * Mandos-tools/utilities
   All of this probably using D-Bus
@@ -48,11 +34,26 @@
 ** TODO Enable client
 ** TODO Reset timer
 
-* mandos-keygen
-** TODO "--secfile" option
-   Using the "secfile" option instead of "secret"
-** TODO [#B] "--test" option
-   For testing decryption before rebooting.
+* Man pages
+** TODO Use xinclude for all common sections
+   Like authors, etc.
+
+
+* Installer
+** Client-side
+*** TODO Update initrd.img after installation
+    This seems to use some kind of "trigger" system
+    [[file:/usr/share/doc/dpkg/triggers.txt.gz]]
+    dpkg-trigger(1), deb-triggers(5)
+*** mandos-keygen
+**** TODO [#A] Ask for password twice for confirmation
+**** TODO "--passfile" option
+     Using the "secfile" option instead of "secret"
+**** TODO [#B] "--test" option
+     For testing decryption before rebooting.
+** Server-side
+*** TODO [#A] Create mandos user and group for server
+
 
 * [#A] Package
 ** /usr/share/initramfs-tools/hooks/mandos
@@ -61,6 +62,22 @@
     question.
 ** TODO /etc/bash_completion.d/mandos
    From XML sources directly?
+** TODO unperish
+** DONE bzr-builddeb
+** DONE mandos user/group creation		:test:
+** DONE Key creation in postinst		:test:
+
+* TODO Web site
+** DONE http://www.fukt.bsnet.se/mandos
+   Redirects to the wiki page
+** TODO http://wiki.fukt.bsnet.se/wiki/Mandos
+
+* Mailing list
+** DONE mandos-dev
+*** TODO http://gmane.org/subscribe.php
+
+* TODO Announce project on Usenet
+  [[news:comp.os.linux.announce]]
 
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2008-09-21 13:42:34 +0000
+++ clients.conf	2008-08-27 01:18:25 +0000
@@ -55,7 +55,7 @@
 ;fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 ;
 ;# If "secret" is not specified, a file can be read for the data.
-;secfile = /etc/mandos/bar-secret.bin
+;;secfile = /etc/mandos/bar-secret.txt.asc
 ;
 ;# An IP address for host is also fine, if the checker accepts it.
 ;host = 192.0.2.3

=== removed file 'common.ent'
--- common.ent	2008-09-30 07:23:39 +0000
+++ common.ent	1970-01-01 00:00:00 +0000
@@ -1,3 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!-- Edited by Makefile -->
-<!ENTITY version "1.0">

=== modified file 'debian/changelog'
--- debian/changelog	2008-10-17 18:56:25 +0000
+++ debian/changelog	2008-09-17 00:34:09 +0000
@@ -1,29 +1,5 @@
-mandos (1.0.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright: Rewritten to conform to
-    <http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233>.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Fri, 17 Oct 2008 20:42:12 +0200
-
-mandos (1.0.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * Separate /usr/share/doc/mandos-client/README.Debian into sections with
-    headlines.  Add instructions on how to test the server and verify the
-    password.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 07 Oct 2008 23:07:23 +0200
-
-mandos (1.0-2) unstable; urgency=low
-
-  * Added comments in debian/*.lintian-overrides files.  Added Debian
-    revison number to version number.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 01 Oct 2008 17:23:35 +0200
-
-mandos (1.0-1) unstable; urgency=low
-
-  * Initial Release. (Closes: #500727).
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 30 Sep 2008 21:58:43 +0200
+mandos (1.0) unstable; urgency=low
+
+  * Initial Release.
+
+ -- Mandos Maintainers <mandos@fukt.bsnet.se>  Sun, 07 Sep 2008 11:55:51 +0200

=== modified file 'debian/control'
--- debian/control	2008-09-30 03:19:39 +0000
+++ debian/control	2008-09-17 00:34:09 +0000
@@ -2,20 +2,17 @@
 Section: admin
 Priority: extra
 Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
-	   Björn Påhlsson <belorn@fukt.bsnet.se>
-Build-Depends: debhelper (>= 7), docbook-xsl, libavahi-core-dev,
-	libgpgme11-dev, libgnutls-dev, xsltproc, po-debconf,
-	pkg-config
+Build-Depends: debhelper (>= 7), docbook-xsl, docbook (<5.0),
+	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc
 Standards-Version: 3.8.0
-Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
+Vcs-Bzr: ftp://anonymous@ftp.fukt.bsnet.se/pub/mandos/latest
 Homepage: http://www.fukt.bsnet.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, avahi-daemon, gnupg (< 2), adduser
+Depends: ${shlibs:Depends}, ${misc:Depends}, python (>=2.5),
+	python-gnutls, python-dbus, python-avahi, avahi-daemon,
+	gnupg (< 2)
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -34,7 +31,7 @@
 
 Package: mandos-client
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2008-10-15 19:54:11 +0000
+++ debian/copyright	2008-09-17 00:34:09 +0000
@@ -1,26 +1,27 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
-Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Upstream-Source: <http://www.fukt.bsnet.se/mandos>
-
-Files: *
-Copyright: Copyright © 2008 Teddy Hogeborn
-Copyright: Copyright © 2008 Björn Påhlsson
-License: GPL-3+
+Authors: Teddy Hogeborn, Björn Påhlsson
+
+Homepage: <http://www.fukt.bsnet.se/mandos>
+
+Copyright:
+
+    Copyright © 2008 Teddy Hogeborn
+                2008 Björn Påhlsson
+
+License:
+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as
     published by the Free Software Foundation, either version 3 of the
     License, or (at your option) any later version.
-    .
+
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.
-    .
+
     You should have received a copy of the GNU General Public License
     along with this program.  If not, see
     <http://www.gnu.org/licenses/>.
-    .
-    On Debian systems, the complete text of the GNU General Public
-    License can be found in "/usr/share/common-licenses/GPL".
+
+On Debian systems, the complete text of the GNU General Public License
+can be found in "/usr/share/common-licenses/GPL".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2008-10-05 17:38:31 +0000
+++ debian/mandos-client.README.Debian	2008-09-19 00:00:51 +0000
@@ -1,45 +1,15 @@
-* Configure The Server
-  
-  A client key has been automatically created in /etc/keys/mandos.
-  The next step is to run "mandos-keygen --password" to get a config
-  file section.  This should be appended to /etc/mandos/clients.conf
-  on the Mandos server.
-
-* Use the Correct Network Interface
-  
-  If some other network interface than "eth0" is used, it will be
-  necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-  change the line there.  If this is done, it will be necessary to
-  update the initrd image by doing "update-initramfs -k all -u".
-
-* Test the Server
-  
-  After the server has been started and this client's key added, it is
-  possible to verify that the correct password will be received by
-  this client by running the command, on the client:
-  
-	# /usr/lib/mandos/plugins.d/mandos-client \
-		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt; echo
-  
-  This command should retrieve the password from the server, decrypt
-  it, and output it to standard output.  It is now possible to verify
-  the correctness of the password before rebooting.
-
-* User-Supplied Plugins
-
-  Any plugins found in /etc/mandos/plugins.d will override and add to
-  the normal Mandos plugins.  When adding or changing plugins, do not
-  forget to update the initital RAM disk image:
-
-	# update-initramfs -k all -u
-
-* Do *NOT* Edit /etc/crypttab
-
-  It is NOT necessary to edit /etc/crypttab to specify
-  /usr/lib/mandos/plugin-runner as a keyscript for the root file
-  system; if no keyscript is given for the root file system, the
-  Mandos client will be the new default way for getting a password for
-  the root file system when booting.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  5 Oct 2008 19:04:26 +0200
+A client key has been automatically created in /etc/keys/mandos.  The
+next step is to run "mandos-keygen --password" to get a config file
+stanza to copy and paste into /etc/mandos/clients.conf on the Mandos
+server.
+
+Also, if some other network interface than "eth0" is used, it will be
+necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
+change the line there.  If this file is changed, it will be necessary
+to update the initrd image by doing "update-initramfs -k all -u".
+
+It is NOT necessary to edit /etc/crypttab to specify
+/usr/lib/mandos/plugin-runner as a keyscript for the root file system;
+if no keyscript is given for the root file system, the Mandos client
+will be the new default way for getting a password for the root file
+system when booting.

=== removed file 'debian/mandos-client.config'
--- debian/mandos-client.config	2008-09-21 04:22:50 +0000
+++ debian/mandos-client.config	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-#! /bin/sh
-#
-# config	Mandos Debconf configuration.
-#
-
-# Source debconf library.
-. /usr/share/debconf/confmodule
-if ! db_version 2.0; then
-    echo "mandos.config: need DebConf 2.0 or later"
-    exit 1
-fi
-
-set -e
-umask 022
-
-# Now, interaction.  Batch it in case any front ends can use this.
-db_beginblock
-
-# If this is a first time install then prompt 
-if [ "$1" = "configure" -a "$2" != "" ]; then
-	db_input high mandos-client/not-yet-configured || true
-fi
-
-db_endblock
-db_go || true
-
-exit 0

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos-client.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2008-10-01 15:29:01 +0000
+++ debian/mandos-client.lintian-overrides	2008-09-17 00:34:09 +0000
@@ -1,32 +1,4 @@
-# This example command line is long without spaces, but it must be
-# that way; it's part of the point of showing it.
-#
 mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz 297: warning [p 4, 5.8i]: can't break line
-
-# This directory contains secret client key files.
-#
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
-
-# The directory /usr/lib/mandos/plugins.d contains setuid binaries
-# which are not meant to be run outside an initial RAM disk
-# environment (except for test purposes).  It would be insecure to
-# allow anyone to run them.
-#
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
 mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755
-
-# These binaries must be setuid root, since they need root powers, but
-# are started by plugin-runner(8mandos), which runs all plugins as
-# user/group "mandos".  These binaries are not run in a running
-# system, but in an initial RAM disk environment.  Here they are
-# protected from non-root access by the directory permissions, above.
-#
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
-
-# The directory /etc/mandos/plugins.d can be used by local system
-# administrators to place plugins in, overriding and complementing
-# /usr/lib/mandos/plugins.d, and must be likewise protected.
-#
-mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2008-09-26 04:54:35 +0000
+++ debian/mandos-client.postinst	2008-09-19 12:02:03 +0000
@@ -17,32 +17,28 @@
 
 . /usr/share/debconf/confmodule
 
-# Update the initial RAM file system image
+# Update the initial RAM filesystem image
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+	if type update-initramfs >/dev/null 2>&1; then
+		update-initramfs -u
+	fi
 }
 
 # Add user and group
 add_mandos_user(){
     if ! getent passwd mandos >/dev/null; then
 	adduser --disabled-password  --quiet --system \
-	    --home /nonexistent --no-create-home \
-	    --gecos "Mandos password system" --group mandos
+	    --home /var/run/mandos --no-create-home \
+	    --gecos "Mandos password daemon" --group mandos
     fi
 }
 
 # Create client key pair
 create_key(){
-    if [ -r /etc/keys/mandos/pubkey.txt \
-	-a -r /etc/keys/mandos/seckey.txt ]; then
-	return 0
-    fi
-    if [ -x /usr/sbin/mandos-keygen ]; then
-	mandos-keygen
-    fi
+	if type mandos-keygen >/dev/null 2>&1; then
+	    mandos-keygen
+	fi
 }
 
 case "$1" in

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2008-09-19 20:54:58 +0000
+++ debian/mandos-client.postrm	2008-09-19 00:00:51 +0000
@@ -27,24 +27,26 @@
 #       <new-postrm> abort-upgrade <old-version>
 
 
-# Update the initial RAM file system image
+# Update the initramfs
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+	if type update-initramfs >/dev/null 2>&1 ; then
+		update-initramfs -u -k all
+	fi
 }
 
+
 case "$1" in
     remove)
 	update_initramfs
 	;;
 
     purge)
-	shred --remove /etc/keys/mandos/seckey.txt 2>/dev/null || :
+	shred --remove /etc/keys/mandos/seckey.txt || :
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
-	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	    /etc/keys/mandos/seckey.txt
+	rmdir /etc/keys/mandos /etc/mandos/plugins.d /etc/mandos || :
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== removed file 'debian/mandos-client.templates'
--- debian/mandos-client.templates	2008-09-21 04:22:50 +0000
+++ debian/mandos-client.templates	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-Template: mandos-client/not-yet-configured
-Type: note
-_Description: Your system needs more configuration[ mandos-client]
- Your system can not function as a Mandos client until a
- password for this client has been added to the
- configuration on the Mandos server.  Please read
- /usr/share/doc/mandos-client/README.Debian.gz to find out
- how.

=== removed file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2008-09-21 04:22:50 +0000
+++ debian/mandos.README.Debian	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-The Mandos server cannot run without at least one configured client in
-/etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and run "mandos-keygen --password" there
-to get a config file stanza.  Append that to /etc/mandos/clients.conf
-on the Mandos server.
-
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sat, 20 Sep 2008 21:21:19 +0200

=== removed file 'debian/mandos.config'
--- debian/mandos.config	2008-09-21 04:22:50 +0000
+++ debian/mandos.config	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-#! /bin/sh
-#
-# config	Mandos Debconf configuration.
-#
-
-# Source debconf library.
-. /usr/share/debconf/confmodule
-if ! db_version 2.0; then
-    echo "mandos.config: need DebConf 2.0 or later"
-    exit 1
-fi
-
-set -e
-umask 022
-
-# Now, interaction.  Batch it in case any front ends can use this.
-db_beginblock
-
-# If this is a first time install then prompt 
-if [ "$1" = "configure" -a "$2" != "" ]; then
-	db_input high mandos/not-yet-configured || true
-fi
-
-db_endblock
-db_go || true
-
-exit 0

=== modified file 'debian/mandos.docs'
--- debian/mandos.docs	2008-10-18 11:17:22 +0000
+++ debian/mandos.docs	2008-09-19 13:50:22 +0000
@@ -1,3 +1,2 @@
-NEWS
 README
 TODO

=== modified file 'debian/mandos.lintian-overrides'
--- debian/mandos.lintian-overrides	2008-10-01 15:29:01 +0000
+++ debian/mandos.lintian-overrides	2008-09-17 00:34:09 +0000
@@ -1,4 +1,1 @@
-# This config file will normally have encrypted secret client keys in
-# it, so it must be kept unreadable for non-root users.
-#
 mandos binary: non-standard-file-perm etc/mandos/clients.conf 0600 != 0644

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2008-09-26 04:54:35 +0000
+++ debian/mandos.postinst	2008-09-19 00:54:24 +0000
@@ -21,8 +21,8 @@
     configure)
 	if ! getent passwd mandos >/dev/null; then
 	    adduser --disabled-password  --quiet --system \
-		--home /nonexistent --no-create-home \
-		--gecos "Mandos password system" --group mandos
+		--home /var/run/mandos --no-create-home \
+		--gecos "Mandos password daemon" --group mandos
 	fi
 	;;
 

=== removed file 'debian/mandos.prerm'
--- debian/mandos.prerm	2008-09-21 13:42:34 +0000
+++ debian/mandos.prerm	1970-01-01 00:00:00 +0000
@@ -1,38 +0,0 @@
-#! /bin/sh
-# prerm script for mandos
-#
-# see: dh_installdeb(1)
-
-set -e
-
-# summary of how this script can be called:
-#        * <prerm> `remove'
-#        * <old-prerm> `upgrade' <new-version>
-#        * <new-prerm> `failed-upgrade' <old-version>
-#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
-#        * <deconfigured's-prerm> `deconfigure' `in-favour'
-#          <package-being-installed> <version> `removing'
-#          <conflicting-package> <version>
-# for details, see /usr/share/doc/packaging-manual/
-
-case "$1" in
-    remove|deconfigure)
-	if [ -x /etc/init.d/mandos ]; then
-		if [ -x /usr/sbin/invoke-rc.d ]; then
-			invoke-rc.d mandos stop
-		else
-			/etc/init.d/mandos stop
-		fi
-	fi
-	;;
-    upgrade|failed-upgrade)
-        ;;
-    *)
-        echo "prerm called with unknown argument \`$1'" >&2
-        exit 0
-    ;;
-esac
-
-#DEBHELPER#
-
-exit 0

=== removed file 'debian/mandos.templates'
--- debian/mandos.templates	2008-09-21 04:22:50 +0000
+++ debian/mandos.templates	1970-01-01 00:00:00 +0000
@@ -1,9 +0,0 @@
-Template: mandos/not-yet-configured
-Type: note
-_Description: Your system needs more configuration[ mandos]
- Your system has not yet been completely configured as a
- Mandos server - clients need to be added to to
- /etc/mandos/clients.conf.  Please read
- /usr/share/doc/mandos/README.Debian.gz to find out how.
- .
- (The server has not been started.)

=== removed directory 'debian/po'
=== removed file 'debian/po/POTFILES.in'
--- debian/po/POTFILES.in	2008-09-21 04:22:50 +0000
+++ debian/po/POTFILES.in	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-[type: gettext/rfc822deb] mandos.templates
-[type: gettext/rfc822deb] mandos-client.templates

=== removed file 'debian/po/sv.po'
--- debian/po/sv.po	2008-09-21 04:22:50 +0000
+++ debian/po/sv.po	1970-01-01 00:00:00 +0000
@@ -1,66 +0,0 @@
-# SOME DESCRIPTIVE TITLE.
-# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the mandos package.
-# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
-#
-msgid ""
-msgstr ""
-"Project-Id-Version: 1.0\n"
-"Report-Msgid-Bugs-To: mandos@packages.debian.org\n"
-"POT-Creation-Date: 2008-09-20 23:01+0200\n"
-"PO-Revision-Date: 2008-09-21 06:01+0200\n"
-"Last-Translator: Teddy Hogeborn <teddy@fukt.bsnet.se>\n"
-"Language-Team: Swedish <tp-sv@listor.tp-sv.se>\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-
-#. Type: note
-#. Description
-#: ../mandos.templates:1001
-msgid "Your system needs more configuration[ mandos]"
-msgstr "Ditt system behöver ytterligare konfigurering"
-
-#. Type: note
-#. Description
-#: ../mandos.templates:1001
-#| msgid ""
-#| "Your system has not yet been completely configured as a Mandos server - "
-#| "you need to setup /etc/mandos/clients.conf. Please read /usr/share/doc/"
-#| "mandos/README.Debian.gz to find out how."
-msgid ""
-"Your system has not yet been completely configured as a Mandos server - "
-"clients need to be added to to /etc/mandos/clients.conf.  Please read /usr/"
-"share/doc/mandos/README.Debian.gz to find out how."
-msgstr ""
-"Ditt system är inte helt inställd som en Mandos-server än -\n"
-"det behövs läggas till klienter i Mandos-serverns\n"
-"inställingar.  Var vänlig läs\n"
-"/usr/share/doc/mandos-client/README.Debian.gz för att få\n"
-"veta hur."
-
-#. Type: note
-#. Description
-#: ../mandos.templates:1001
-msgid "(The server has not been started.)"
-msgstr "(Servern har inte startats.)"
-
-#. Type: note
-#. Description
-#: ../mandos-client.templates:1001
-msgid "Your system needs more configuration[ mandos-client]"
-msgstr "Ditt system behöver ytterligare konfigurering"
-
-#. Type: note
-#. Description
-#: ../mandos-client.templates:1001
-msgid ""
-"Your system can not function as a Mandos client until a password for this "
-"client has been added to the configuration on the Mandos server.  Please "
-"read /usr/share/doc/mandos-client/README.Debian.gz to find out how."
-msgstr ""
-"Ditt system kan inte fungera som en Mandos-klient förrän\n"
-"ett krypterat lösenord har lagts till i Mandos-serverns\n"
-"inställingar.  Var vänlig läs\n"
-"/usr/share/doc/mandos-client/README.Debian.gz för att få\n"
-"veta hur."

=== modified file 'debian/rules'
--- debian/rules	2008-09-30 18:59:44 +0000
+++ debian/rules	2008-09-19 13:50:22 +0000
@@ -38,7 +38,6 @@
 	rm -f build-arch-stamp build-indep-stamp configure-stamp
 	dh_auto_clean
 	dh_clean
-	debconf-updatepo
 
 install: install-indep install-arch
 install-indep:
@@ -48,8 +47,7 @@
 	dh_installdirs --indep
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
 	dh_lintian
-	dh_installinit --onlyscripts --no-start \
-		--update-rcd-params="defaults 25 15"
+	dh_installinit --onlyscripts --no-start
 	dh_install --indep
 
 install-arch:
@@ -66,13 +64,12 @@
 	dh_testroot
 	dh_installchangelogs
 	dh_installdocs
-	dh_installdebconf
+#	dh_installdebconf
 	dh_link
 	dh_strip
 	dh_compress
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
-		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/mandos/plugins.d
 	dh_installdeb
 	dh_shlibdeps

=== added file 'etc-plugins.d-README'
--- etc-plugins.d-README	1970-01-01 00:00:00 +0000
+++ etc-plugins.d-README	2008-09-06 16:11:50 +0000
@@ -0,0 +1,5 @@
+Any plugins found here in /etc/mandos/plugins.d will override and add
+to the normal Mandos plugins.  When adding or changing plugins, do not
+forget to update the initital RAM disk image:
+
+# update-initramfs -k all -u

=== modified file 'init.d-mandos'
--- init.d-mandos	2008-09-21 12:04:02 +0000
+++ init.d-mandos	2008-09-05 16:24:33 +0000
@@ -1,7 +1,7 @@
 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides:          mandos
-# Required-Start:    $remote_fs avahi-daemon
+# Required-Start:    $remote_fs
 # Required-Stop:     $remote_fs
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2008-11-01 02:26:00 +0000
+++ initramfs-tools-hook	2008-09-19 00:54:24 +0000
@@ -89,7 +89,7 @@
 	continue
     fi
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac
@@ -99,7 +99,7 @@
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac

=== modified file 'mandos'
--- mandos	2008-11-11 16:07:18 +0000
+++ mandos	2008-09-05 18:37:28 +0000
@@ -11,8 +11,7 @@
 # and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008 Teddy Hogeborn
-# Copyright © 2008 Björn Påhlsson
+# Copyright © 2007-2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,10 +30,11 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-from __future__ import division, with_statement, absolute_import
+from __future__ import division
 
 import SocketServer
 import socket
+import select
 from optparse import OptionParser
 import datetime
 import errno
@@ -56,24 +56,21 @@
 import logging
 import logging.handlers
 import pwd
-from contextlib import closing
 
 import dbus
-import dbus.service
 import gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
-import ctypes.util
 
-version = "1.0.2"
+version = "1.0"
 
 logger = logging.Logger('mandos')
-syslogger = (logging.handlers.SysLogHandler
-             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
-syslogger.setFormatter(logging.Formatter
-                       ('Mandos: %(levelname)s: %(message)s'))
+syslogger = logging.handlers.SysLogHandler\
+            (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+             address = "/dev/log")
+syslogger.setFormatter(logging.Formatter\
+                        ('Mandos: %(levelname)s: %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
@@ -84,7 +81,6 @@
 class AvahiError(Exception):
     def __init__(self, value):
         self.value = value
-        super(AvahiError, self).__init__()
     def __str__(self):
         return repr(self.value)
 
@@ -112,13 +108,16 @@
                   a sensible number of times
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768):
+                 type = None, port = None, TXT = None, domain = "",
+                 host = "", max_renames = 32768):
         self.interface = interface
         self.name = name
-        self.type = servicetype
+        self.type = type
         self.port = port
-        self.TXT = TXT if TXT is not None else []
+        if TXT is None:
+            self.TXT = []
+        else:
+            self.TXT = TXT
         self.domain = domain
         self.host = host
         self.rename_count = 0
@@ -128,14 +127,14 @@
         if self.rename_count >= self.max_renames:
             logger.critical(u"No suitable Zeroconf service name found"
                             u" after %i retries, exiting.",
-                            self.rename_count)
+                            rename_count)
             raise AvahiServiceError("Too many renames")
         self.name = server.GetAlternativeServiceName(self.name)
         logger.info(u"Changing Zeroconf service name to %r ...",
                     str(self.name))
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
-                                ' %%(message)s' % self.name))
+                               ' %%(message)s' % self.name))
         self.remove()
         self.add()
         self.rename_count += 1
@@ -147,10 +146,10 @@
         """Derived from the Avahi example code"""
         global group
         if group is None:
-            group = dbus.Interface(bus.get_object
-                                   (avahi.DBUS_NAME,
+            group = dbus.Interface\
+                    (bus.get_object(avahi.DBUS_NAME,
                                     server.EntryGroupNew()),
-                                   avahi.DBUS_INTERFACE_ENTRY_GROUP)
+                     avahi.DBUS_INTERFACE_ENTRY_GROUP)
             group.connect_to_signal('StateChanged',
                                     entry_group_state_changed)
         logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
@@ -170,7 +169,7 @@
 # End of Avahi example code
 
 
-class Client(dbus.service.Object):
+class Client(object):
     """A representation of a client host served by this server.
     Attributes:
     name:      string; from the config file, used in log messages
@@ -178,9 +177,8 @@
                  uniquely identify the client
     secret:    bytestring; sent verbatim (over TLS) to client
     host:      string; available for use by the checker command
-    created:   datetime.datetime(); (UTC) object creation
-    started:   datetime.datetime(); (UTC) last started
-    last_checked_ok: datetime.datetime(); (UTC) or None
+    created:   datetime.datetime(); object creation, not client host
+    last_checked_ok: datetime.datetime() or None if not yet checked OK
     timeout:   datetime.timedelta(); How long from last_checked_ok
                                      until this client is invalid
     interval:  datetime.timedelta(); How often to start a new checker
@@ -202,20 +200,18 @@
     _interval_milliseconds: - '' -
     """
     def _set_timeout(self, timeout):
-        "Setter function for the 'timeout' attribute"
+        "Setter function for 'timeout' attribute"
         self._timeout = timeout
         self._timeout_milliseconds = ((self.timeout.days
                                        * 24 * 60 * 60 * 1000)
                                       + (self.timeout.seconds * 1000)
                                       + (self.timeout.microseconds
                                          // 1000))
-        # Emit D-Bus signal
-        self.TimeoutChanged(self._timeout_milliseconds)
-    timeout = property(lambda self: self._timeout, _set_timeout)
+    timeout = property(lambda self: self._timeout,
+                       _set_timeout)
     del _set_timeout
-    
     def _set_interval(self, interval):
-        "Setter function for the 'interval' attribute"
+        "Setter function for 'interval' attribute"
         self._interval = interval
         self._interval_milliseconds = ((self.interval.days
                                         * 24 * 60 * 60 * 1000)
@@ -223,41 +219,32 @@
                                           * 1000)
                                        + (self.interval.microseconds
                                           // 1000))
-        # Emit D-Bus signal
-        self.IntervalChanged(self._interval_milliseconds)
-    interval = property(lambda self: self._interval, _set_interval)
+    interval = property(lambda self: self._interval,
+                        _set_interval)
     del _set_interval
-    
-    def __init__(self, name = None, stop_hook=None, config=None):
+    def __init__(self, name = None, stop_hook=None, config={}):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
-        dbus.service.Object.__init__(self, bus,
-                                     "/Mandos/clients/%s"
-                                     % name.replace(".", "_"))
-        if config is None:
-            config = {}
         self.name = name
         logger.debug(u"Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
-        self.fingerprint = (config["fingerprint"].upper()
-                            .replace(u" ", u""))
+        self.fingerprint = config["fingerprint"].upper()\
+                           .replace(u" ", u"")
         logger.debug(u"  Fingerprint: %s", self.fingerprint)
         if "secret" in config:
             self.secret = config["secret"].decode(u"base64")
         elif "secfile" in config:
-            with closing(open(os.path.expanduser
-                              (os.path.expandvars
-                               (config["secfile"])))) as secfile:
-                self.secret = secfile.read()
+            sf = open(config["secfile"])
+            self.secret = sf.read()
+            sf.close()
         else:
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get("host", "")
-        self.created = datetime.datetime.utcnow()
-        self.started = None
+        self.created = datetime.datetime.now()
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
         self.interval = string_to_delta(config["interval"])
@@ -267,28 +254,27 @@
         self.stop_initiator_tag = None
         self.checker_callback_tag = None
         self.check_command = config["checker"]
-    
     def start(self):
         """Start this client's checker and timeout hooks"""
-        self.started = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self._interval_milliseconds,
-                                       self.start_checker))
+        self.checker_initiator_tag = gobject.timeout_add\
+                                     (self._interval_milliseconds,
+                                      self.start_checker)
         # Also start a new checker *right now*.
         self.start_checker()
         # Schedule a stop() when 'timeout' has passed
-        self.stop_initiator_tag = (gobject.timeout_add
-                                   (self._timeout_milliseconds,
-                                    self.stop))
-        # Emit D-Bus signal
-        self.StateChanged(True)
-    
+        self.stop_initiator_tag = gobject.timeout_add\
+                                  (self._timeout_milliseconds,
+                                   self.stop)
     def stop(self):
-        """Stop this client."""
-        if getattr(self, "started", None) is not None:
+        """Stop this client.
+        The possibility that a client might be restarted is left open,
+        but not currently used."""
+        # If this client doesn't have a secret, it is already stopped.
+        if hasattr(self, "secret") and self.secret:
             logger.info(u"Stopping client %s", self.name)
+            self.secret = None
         else:
             return False
         if getattr(self, "stop_initiator_tag", False):
@@ -300,49 +286,31 @@
         self.stop_checker()
         if self.stop_hook:
             self.stop_hook(self)
-        self.started = None
-        # Emit D-Bus signal
-        self.StateChanged(False)
         # Do not run this again if called by a gobject.timeout_add
         return False
-    
     def __del__(self):
         self.stop_hook = None
         self.stop()
-    
     def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
+        now = datetime.datetime.now()
         self.checker_callback_tag = None
         self.checker = None
-        if (os.WIFEXITED(condition) 
-            and (os.WEXITSTATUS(condition) == 0)):
+        if os.WIFEXITED(condition) \
+               and (os.WEXITSTATUS(condition) == 0):
             logger.info(u"Checker for %(name)s succeeded",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(True)
-            self.bump_timeout()
+            self.last_checked_ok = now
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = gobject.timeout_add\
+                                      (self._timeout_milliseconds,
+                                       self.stop)
         elif not os.WIFEXITED(condition):
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
         else:
             logger.info(u"Checker for %(name)s failed",
                         vars(self))
-            # Emit D-Bus signal
-            self.CheckerCompleted(False)
-    
-    def bump_timeout(self):
-        """Bump up the timeout for this client.
-        This should only be called when the client has been seen,
-        alive and well.
-        """
-        self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.stop_initiator_tag)
-        self.stop_initiator_tag = (gobject.timeout_add
-                                   (self._timeout_milliseconds,
-                                    self.stop))
-    
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
@@ -380,17 +348,14 @@
                 self.checker = subprocess.Popen(command,
                                                 close_fds=True,
                                                 shell=True, cwd="/")
-                self.checker_callback_tag = (gobject.child_watch_add
-                                             (self.checker.pid,
-                                              self.checker_callback))
-                # Emit D-Bus signal
-                self.CheckerStarted(command)
+                self.checker_callback_tag = gobject.child_watch_add\
+                                            (self.checker.pid,
+                                             self.checker_callback)
             except OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
         return True
-    
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
         if self.checker_callback_tag:
@@ -408,183 +373,26 @@
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
-    
     def still_valid(self):
         """Has the timeout not yet passed for this client?"""
-        if not self.started:
-            return False
-        now = datetime.datetime.utcnow()
+        now = datetime.datetime.now()
         if self.last_checked_ok is None:
             return now < (self.created + self.timeout)
         else:
             return now < (self.last_checked_ok + self.timeout)
-    
-    ## D-Bus methods & signals
-    _interface = u"org.mandos_system.Mandos.Client"
-    
-    def _datetime_to_dbus_struct(dt):
-        return dbus.Struct(dt.year, dt.month, dt.day, dt.hour,
-                           dt.minute, dt.second, dt.microsecond,
-                           signature="nyyyyyu")
-    
-    # BumpTimeout - method
-    BumpTimeout = dbus.service.method(_interface)(bump_timeout)
-    BumpTimeout.__name__ = "BumpTimeout"
-    
-    # IntervalChanged - signal
-    @dbus.service.signal(_interface, signature="t")
-    def IntervalChanged(self, t):
-        "D-Bus signal"
-        pass
-    
-    # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="b")
-    def CheckerCompleted(self, success):
-        "D-Bus signal"
-        pass
-    
-    # CheckerIsRunning - method
-    @dbus.service.method(_interface, out_signature="b")
-    def CheckerIsRunning(self):
-        "D-Bus getter method"
-        return self.checker is not None
-    
-    # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature="s")
-    def CheckerStarted(self, command):
-        "D-Bus signal"
-        pass
-    
-    # GetChecker - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetChecker(self):
-        "D-Bus getter method"
-        return self.checker_command
-    
-    # GetCreated - method
-    @dbus.service.method(_interface, out_signature="(nyyyyyu)")
-    def GetCreated(self):
-        "D-Bus getter method"
-        return datetime_to_dbus_struct(self.created)
-    
-    # GetFingerprint - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetFingerprint(self):
-        "D-Bus getter method"
-        return self.fingerprint
-    
-    # GetHost - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetHost(self):
-        "D-Bus getter method"
-        return self.host
-    
-    # GetInterval - method
-    @dbus.service.method(_interface, out_signature="t")
-    def GetInterval(self):
-        "D-Bus getter method"
-        return self._interval_milliseconds
-    
-    # GetName - method
-    @dbus.service.method(_interface, out_signature="s")
-    def GetName(self):
-        "D-Bus getter method"
-        return self.name
-    
-    # GetStarted - method
-    @dbus.service.method(_interface, out_signature="(nyyyyyu)")
-    def GetStarted(self):
-        "D-Bus getter method"
-        if self.started is not None:
-            return datetime_to_dbus_struct(self.started)
-        else:
-            return dbus.Struct(0, 0, 0, 0, 0, 0, 0,
-                               signature="nyyyyyu")
-    
-    # GetTimeout - method
-    @dbus.service.method(_interface, out_signature="t")
-    def GetTimeout(self):
-        "D-Bus getter method"
-        return self._timeout_milliseconds
-    
-    # SetChecker - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetChecker(self, checker):
-        "D-Bus setter method"
-        self.checker_command = checker
-    
-    # SetHost - method
-    @dbus.service.method(_interface, in_signature="s")
-    def SetHost(self, host):
-        "D-Bus setter method"
-        self.host = host
-    
-    # SetInterval - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetInterval(self, milliseconds):
-        self.interval = datetime.timdeelta(0, 0, 0, milliseconds)
-    
-    # SetTimeout - method
-    @dbus.service.method(_interface, in_signature="t")
-    def SetTimeout(self, milliseconds):
-        self.timeout = datetime.timedelta(0, 0, 0, milliseconds)
-    
-    # SetSecret - method
-    @dbus.service.method(_interface, in_signature="ay",
-                         byte_arrays=True)
-    def SetSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = str(secret)
-    
-    # Start - method
-    Start = dbus.service.method(_interface)(start)
-    Start.__name__ = "Start"
-    
-    # StartChecker - method
-    StartChecker = dbus.service.method(_interface)(start_checker)
-    StartChecker.__name__ = "StartChecker"
-    
-    # StateChanged - signal
-    @dbus.service.signal(_interface, signature="b")
-    def StateChanged(self, started):
-        "D-Bus signal"
-        pass
-    
-    # StillValid - method
-    StillValid = (dbus.service.method(_interface, out_signature="b")
-                  (still_valid))
-    StillValid.__name__ = "StillValid"
-    
-    # Stop - method
-    Stop = dbus.service.method(_interface)(stop)
-    Stop.__name__ = "Stop"
-    
-    # StopChecker - method
-    StopChecker = dbus.service.method(_interface)(stop_checker)
-    StopChecker.__name__ = "StopChecker"
-    
-    # TimeoutChanged - signal
-    @dbus.service.signal(_interface, signature="t")
-    def TimeoutChanged(self, t):
-        "D-Bus signal"
-        pass
-    
-    del _datetime_to_dbus_struct
-    del _interface
 
 
 def peer_certificate(session):
     "Return the peer's OpenPGP certificate as a bytestring"
     # If not an OpenPGP certificate...
-    if (gnutls.library.functions
-        .gnutls_certificate_type_get(session._c_object)
-        != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
+    if gnutls.library.functions.gnutls_certificate_type_get\
+            (session._c_object) \
+           != gnutls.library.constants.GNUTLS_CRT_OPENPGP:
         # ...do the normal thing
         return session.peer_certificate
     list_size = ctypes.c_uint()
-    cert_list = (gnutls.library.functions
-                 .gnutls_certificate_get_peers
-                 (session._c_object, ctypes.byref(list_size)))
+    cert_list = gnutls.library.functions.gnutls_certificate_get_peers\
+        (session._c_object, ctypes.byref(list_size))
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -594,55 +402,50 @@
 def fingerprint(openpgp):
     "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
     # New GnuTLS "datum" with the OpenPGP public key
-    datum = (gnutls.library.types
-             .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                         ctypes.POINTER
-                                         (ctypes.c_ubyte)),
-                             ctypes.c_uint(len(openpgp))))
+    datum = gnutls.library.types.gnutls_datum_t\
+        (ctypes.cast(ctypes.c_char_p(openpgp),
+                     ctypes.POINTER(ctypes.c_ubyte)),
+         ctypes.c_uint(len(openpgp)))
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+    gnutls.library.functions.gnutls_openpgp_crt_init\
+        (ctypes.byref(crt))
     # Import the OpenPGP public key into the certificate
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                gnutls.library.constants
-                                .GNUTLS_OPENPGP_FMT_RAW))
+    gnutls.library.functions.gnutls_openpgp_crt_import\
+                    (crt, ctypes.byref(datum),
+                     gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
     # Verify the self signature in the key
-    crtverify = ctypes.c_uint()
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_verify_self(crt, 0, ctypes.byref(crtverify)))
+    crtverify = ctypes.c_uint();
+    gnutls.library.functions.gnutls_openpgp_crt_verify_self\
+        (crt, 0, ctypes.byref(crtverify))
     if crtverify.value != 0:
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         raise gnutls.errors.CertificateSecurityError("Verify failed")
     # New buffer for the fingerprint
-    buf = ctypes.create_string_buffer(20)
-    buf_len = ctypes.c_size_t()
+    buffer = ctypes.create_string_buffer(20)
+    buffer_length = ctypes.c_size_t()
     # Get the fingerprint from the certificate into the buffer
-    (gnutls.library.functions
-     .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                         ctypes.byref(buf_len)))
+    gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint\
+        (crt, ctypes.byref(buffer), ctypes.byref(buffer_length))
     # Deinit the certificate
     gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
     # Convert the buffer to a Python bytestring
-    fpr = ctypes.string_at(buf, buf_len.value)
+    fpr = ctypes.string_at(buffer, buffer_length.value)
     # Convert the bytestring to hexadecimal notation
     hex_fpr = u''.join(u"%02X" % ord(char) for char in fpr)
     return hex_fpr
 
 
-class TCP_handler(SocketServer.BaseRequestHandler, object):
+class tcp_handler(SocketServer.BaseRequestHandler, object):
     """A TCP request handler class.
     Instantiated by IPv6_TCPServer for each request to handle it.
     Note: This will run in its own forked process."""
     
     def handle(self):
         logger.info(u"TCP connection from: %s",
-                    unicode(self.client_address))
-        session = (gnutls.connection
-                   .ClientSession(self.request,
-                                  gnutls.connection
-                                  .X509Credentials()))
+                     unicode(self.client_address))
+        session = gnutls.connection.ClientSession\
+                  (self.request, gnutls.connection.X509Credentials())
         
         line = self.request.makefile().readline()
         logger.debug(u"Protocol version: %r", line)
@@ -661,11 +464,12 @@
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
         #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
         #                "+DHE-DSS"))
-        # Use a fallback default, since this MUST be set.
-        priority = self.server.settings.get("priority", "NORMAL")
-        (gnutls.library.functions
-         .gnutls_priority_set_direct(session._c_object,
-                                     priority, None))
+        priority = "NORMAL"             # Fallback default, since this
+                                        # MUST be set.
+        if self.server.settings["priority"]:
+            priority = self.server.settings["priority"]
+        gnutls.library.functions.gnutls_priority_set_direct\
+            (session._c_object, priority, None);
         
         try:
             session.handshake()
@@ -681,11 +485,12 @@
             session.bye()
             return
         logger.debug(u"Fingerprint: %s", fpr)
+        client = None
         for c in self.server.clients:
             if c.fingerprint == fpr:
                 client = c
                 break
-        else:
+        if not client:
             logger.warning(u"Client not found for fingerprint: %s",
                            fpr)
             session.bye()
@@ -698,8 +503,6 @@
                            vars(client))
             session.bye()
             return
-        ## This won't work here, since we're in a fork.
-        # client.bump_timeout()
         sent_size = 0
         while sent_size < len(client.secret):
             sent = session.send(client.secret[sent_size:])
@@ -710,8 +513,7 @@
         session.bye()
 
 
-class IPv6_TCPServer(SocketServer.ForkingMixIn,
-                     SocketServer.TCPServer, object):
+class IPv6_TCPServer(SocketServer.ForkingTCPServer, object):
     """IPv6 TCP server.  Accepts 'None' as address and/or port.
     Attributes:
         settings:       Server settings
@@ -727,7 +529,7 @@
             self.clients = kwargs["clients"]
             del kwargs["clients"]
         self.enabled = False
-        super(IPv6_TCPServer, self).__init__(*args, **kwargs)
+        return super(type(self), self).__init__(*args, **kwargs)
     def server_bind(self):
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
@@ -762,10 +564,10 @@
 #                                            if_nametoindex
 #                                            (self.settings
 #                                             ["interface"]))
-            return super(IPv6_TCPServer, self).server_bind()
+            return super(type(self), self).server_bind()
     def server_activate(self):
         if self.enabled:
-            return super(IPv6_TCPServer, self).server_activate()
+            return super(type(self), self).server_activate()
     def enable(self):
         self.enabled = True
 
@@ -789,8 +591,8 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = unicode(s[-1])
-            value = int(s[:-1])
+            suffix=unicode(s[-1])
+            value=int(s[:-1])
             if suffix == u"d":
                 delta = datetime.timedelta(value)
             elif suffix == u"s":
@@ -836,9 +638,10 @@
     """Call the C function if_nametoindex(), or equivalent"""
     global if_nametoindex
     try:
-        if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library("c"))
-                          .if_nametoindex)
+        if "ctypes.util" not in sys.modules:
+            import ctypes.util
+        if_nametoindex = ctypes.cdll.LoadLibrary\
+            (ctypes.util.find_library("c")).if_nametoindex
     except (OSError, AttributeError):
         if "struct" not in sys.modules:
             import struct
@@ -847,9 +650,10 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack("16s16x", interface))
+            s = socket.socket()
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack("16s16x", interface))
+            s.close()
             interface_index = struct.unpack("I", ifreq[16:20])[0]
             return interface_index
     return if_nametoindex(interface)
@@ -879,6 +683,9 @@
 
 
 def main():
+    global main_loop_started
+    main_loop_started = False
+    
     parser = OptionParser(version = "%%prog %s" % version)
     parser.add_option("-i", "--interface", type="string",
                       metavar="IF", help="Bind to interface IF")
@@ -899,7 +706,7 @@
                       default="/etc/mandos", metavar="DIR",
                       help="Directory to search for configuration"
                       " files")
-    options = parser.parse_args()[0]
+    (options, args) = parser.parse_args()
     
     if options.check:
         import doctest
@@ -923,8 +730,8 @@
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use getboolean on the boolean config option
-    server_settings["debug"] = (server_config.getboolean
-                                ("DEFAULT", "debug"))
+    server_settings["debug"] = server_config.getboolean\
+                               ("DEFAULT", "debug")
     del server_config
     
     # Override the settings from the config file with command line
@@ -944,7 +751,7 @@
         console.setLevel(logging.WARNING)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(logging.Formatter
+        syslogger.setFormatter(logging.Formatter\
                                ('Mandos (%s): %%(levelname)s:'
                                 ' %%(message)s'
                                 % server_settings["servicename"]))
@@ -962,7 +769,7 @@
     clients = Set()
     tcp_server = IPv6_TCPServer((server_settings["address"],
                                  server_settings["port"]),
-                                TCP_handler,
+                                tcp_handler,
                                 settings=server_settings,
                                 clients=clients)
     pidfilename = "/var/run/mandos.pid"
@@ -996,10 +803,10 @@
     
     global service
     service = AvahiService(name = server_settings["servicename"],
-                           servicetype = "_mandos._tcp", )
+                           type = "_mandos._tcp", );
     if server_settings["interface"]:
-        service.interface = (if_nametoindex
-                             (server_settings["interface"]))
+        service.interface = if_nametoindex\
+                            (server_settings["interface"])
     
     global main_loop
     global bus
@@ -1012,7 +819,6 @@
                                            avahi.DBUS_PATH_SERVER),
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
-    bus_name = dbus.service.BusName(u"org.mandos-system.Mandos", bus)
     
     def remove_from_clients(client):
         clients.remove(client)
@@ -1046,7 +852,7 @@
         pidfile.write(str(pid) + "\n")
         pidfile.close()
         del pidfile
-    except IOError:
+    except IOError, err:
         logger.error(u"Could not write to file %r with PID %d",
                      pidfilename, pid)
     except NameError:
@@ -1100,10 +906,11 @@
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:
-                             (tcp_server.handle_request
-                              (*args[2:], **kwargs) or True))
+                             tcp_server.handle_request\
+                             (*args[2:], **kwargs) or True)
         
         logger.debug(u"Starting main loop")
+        main_loop_started = True
         main_loop.run()
     except AvahiError, error:
         logger.critical(u"AvahiError: %s" + unicode(error))

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2008-10-07 21:31:09 +0000
+++ mandos-clients.conf.xml	2008-09-12 19:12:40 +0000
@@ -1,11 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2008-10-07">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -13,7 +12,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -240,11 +239,6 @@
 	    should <emphasis>not</emphasis> be base64-encoded, but
 	    will be sent to clients verbatim.
 	  </para>
-	  <para>
-	    File names of the form <filename>~user/foo/bar</filename>
-	    and <filename>$<envar>ENVVAR</envar>/foo/bar</filename>
-	    are supported.
-	  </para>
 	</listitem>
       </varlistentry>
       

=== modified file 'mandos-keygen'
--- mandos-keygen	2008-11-11 16:07:18 +0000
+++ mandos-keygen	2008-09-08 12:03:16 +0000
@@ -2,8 +2,7 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008 Teddy Hogeborn
-# Copyright © 2008 Björn Påhlsson
+# Copyright © 2007-2008 Teddy Hogeborn & Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,14 +20,14 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.2"
+VERSION="1.0"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
 KEYLENGTH=2048
 SUBKEYTYPE=ELG-E
 SUBKEYLENGTH=2048
-KEYNAME="`hostname --fqdn 2>/dev/null || hostname`"
+KEYNAME="`hostname --fqdn`"
 KEYEMAIL=""
 KEYCOMMENT="Mandos client key"
 KEYEXPIRE=0
@@ -41,8 +40,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
+TEMP=`getopt --options vhd:t:l:n:e:c:x:f \
+    --longoptions version,help,password,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -54,7 +53,6 @@
        $basename [ OPTIONS ]
    Encrypted password creation:
        $basename { -p | --password } [ --name NAME ] [ --dir DIR]
-       $basename { -F | --passfile } FILE [ --name NAME ] [ --dir DIR]
 
 Key creation options:
   -v, --version         Show program's version number and exit
@@ -76,14 +74,10 @@
   -x TIME, --expire TIME
                         Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
-  -f, --force           Force overwriting old key files.
+  -f, --force           Force overwriting old keys.
 
 Password creation options:
-  -p, --password        Create an encrypted password using the key in
-                        the key directory.  All options other than
-                        --dir and --name are ignored.
-  -F FILE, --passfile FILE
-                        Encrypt a password from FILE using the key in
+  -p, --password        Create an encrypted password using the keys in
                         the key directory.  All options other than
                         --dir and --name are ignored.
 EOF
@@ -93,7 +87,6 @@
 while :; do
     case "$1" in
 	-p|--password) mode=password; shift;;
-	-F|--passfile) mode=password; PASSFILE="$2"; shift 2;;
 	-d|--dir) KEYDIR="$2"; shift 2;;
 	-t|--type) KEYTYPE="$2"; shift 2;;
 	-s|--subtype) SUBKEYTYPE="$2"; shift 2;;
@@ -242,7 +235,7 @@
 	FILECOMMENT="$FILECOMMENT <$KEYEMAIL>"
     fi
     
-    # Export key from key rings to key files
+    # Export keys from key rings to key files
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --armor --export-options export-minimal \
 	--comment "$FILECOMMENT" --output "$SECKEYFILE" \
@@ -253,7 +246,7 @@
 fi
 
 if [ "$mode" = password ]; then
-    # Import key into temporary key rings
+    # Import keys into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
 	--import "$SECKEYFILE"
@@ -272,37 +265,22 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    if [ -n "$PASSFILE" ]; then
-	cat "$PASSFILE"
-    else
-	stty -echo
-	echo -n "Enter passphrase: " >&2
-	first="$(head --lines=1 | tr --delete '\n')"
-	echo -n -e "\nRepeat passphrase: " >&2
-	second="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	stty echo
-	if [ "$first" != "$second" ]; then
-	    echo -e "Passphrase mismatch" >&2
-	    false
-	else
-	    echo -n "$first"
-	fi
-    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+    stty -echo
+    echo -n "Enter passphrase: " >&2
+    head --lines=1 | tr --delete '\n' \
+	| gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
+	--recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
-    status="${PIPESTATUS[0]}"
-    if [ "$status" -ne 0 ]; then
-	exit "$status"
-    fi
+    echo >&2
+    stty echo
     
     cat <<-EOF
 	[$KEYNAME]
 	host = $KEYNAME
 	fingerprint = $FINGERPRINT
 	secret =
-	EOF
+EOF
     sed --quiet --expression='
 	/^-----BEGIN PGP MESSAGE-----$/,/^-----END PGP MESSAGE-----$/{
 	    /^$/,${

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2008-10-04 01:55:56 +0000
+++ mandos-keygen.xml	2008-09-12 19:12:40 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -123,10 +122,6 @@
       <group choice="req">
 	<arg choice="plain"><option>--password</option></arg>
 	<arg choice="plain"><option>-p</option></arg>
-	<arg choice="plain"><option>--passfile
-	<replaceable>FILE</replaceable></option></arg>
-	<arg choice="plain"><option>-F</option>
-	<replaceable>FILE</replaceable></arg>
       </group>
       <sbr/>
       <group>
@@ -172,9 +167,8 @@
     </para>
     <para>
       This program can also be used with the
-      <option>--password</option> or <option>--passfile</option>
-      options to generate a ready-made section for
-      <filename>clients.conf</filename> (see
+      <option>--password</option> option to generate a ready-made
+      section for <filename>clients.conf</filename> (see
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>).
     </para>
@@ -332,18 +326,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--passfile
-	<replaceable>FILE</replaceable></option></term>
-	<term><option>-F
-	<replaceable>FILE</replaceable></option></term>
-	<listitem>
-	  <para>
-	    The same as <option>--password</option>, but read from
-	    <replaceable>FILE</replaceable>, not the terminal.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -382,7 +364,7 @@
     </variablelist>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <para>
       Use the <option>--dir</option> option to change where

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2008-09-30 03:19:39 +0000
+++ mandos-options.xml	2008-09-06 16:31:49 +0000
@@ -58,8 +58,8 @@
   <para id="servicename">
     Zeroconf service name.  The default is
     <quote><literal>Mandos</literal></quote>.  This only needs to be
-    changed if for some reason is would be necessary to run more than
-    one server on the same <emphasis>host</emphasis>.  This would not
+    changed this if it, for some reason, is necessary to run more than
+    one server on the same <emphasis>host</emphasis>, which would not
     normally be useful.  If there are name collisions on the same
     <emphasis>network</emphasis>, the newer server will automatically
     rename itself to <quote><literal>Mandos #2</literal></quote>, and

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2008-09-30 07:23:39 +0000
+++ mandos.conf.xml	2008-09-12 19:12:40 +0000
@@ -1,11 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2008-09-30">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -13,7 +12,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>

=== removed file 'mandos.lsm'
--- mandos.lsm	2008-10-18 10:58:29 +0000
+++ mandos.lsm	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-Begin4
-Title:		Mandos
-Version:	1.0.2
-Entered-date:	2008-10-18
-Description:	The Mandos system allows computers to have encrypted
-root file systems and at the same time be capable of remote and/or
-unattended reboots.
-Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      89K mandos_1.0.2.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		89K mandos_1.0.2.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
-various other libraries.  While made for Debian GNU/Linux, it is
-probably portable to other distributions, but not other Unixes.
-Copying-policy: GNU General Public License version 3.0 or later
-End

=== modified file 'mandos.xml'
--- mandos.xml	2008-10-04 01:55:56 +0000
+++ mandos.xml	2008-09-12 19:12:40 +0000
@@ -1,18 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-   <refentryinfo>
+  <refentryinfo>
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -351,7 +350,7 @@
     </variablelist>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <para>
       Use the <option>--configdir</option> option to change where
@@ -421,7 +420,7 @@
       Currently, if a client is declared <quote>invalid</quote> due to
       having timed out, the server does not record this fact onto
       permanent storage.  This has some security implications, see
-      <xref linkend="clients"/>.
+      <xref linkend="CLIENTS"/>.
     </para>
     <para>
       There is currently no way of querying the server of the current
@@ -483,7 +482,7 @@
   
   <refsect1 id="security">
     <title>SECURITY</title>
-    <refsect2 id="server">
+    <refsect2 id="SERVER">
       <title>SERVER</title>
       <para>
 	Running this <command>&COMMANDNAME;</command> server program
@@ -492,7 +491,7 @@
 	soon after startup.
       </para>
     </refsect2>
-    <refsect2 id="clients">
+    <refsect2 id="CLIENTS">
       <title>CLIENTS</title>
       <para>
 	The server only gives out its stored data to clients which
@@ -505,7 +504,7 @@
 	<citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
 	<manvolnum>5</manvolnum></citerefentry>)
 	<emphasis>must</emphasis> be made non-readable by anyone
-	except the user starting the server (usually root).
+	except the user running the server.
       </para>
       <para>
 	As detailed in <xref linkend="checking"/>, the status of all

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2008-11-11 16:07:18 +0000
+++ plugin-runner.c	2008-09-19 00:00:51 +0000
@@ -2,8 +2,7 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ * Copyright © 2007-2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -28,8 +27,8 @@
 #include <stdlib.h>		/* malloc(), exit(), EXIT_FAILURE,
 				   EXIT_SUCCESS, realloc() */
 #include <stdbool.h>		/* bool, true, false */
-#include <stdio.h>		/* perror, fileno(), fprintf(),
-				   stderr, STDOUT_FILENO */
+#include <stdio.h>		/* perror, popen(), fileno(),
+				   fprintf(), stderr, STDOUT_FILENO */
 #include <sys/types.h>	        /* DIR, opendir(), stat(), struct
 				   stat, waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), wait(), pid_t,
@@ -47,7 +46,7 @@
 				   fcntl(), setuid(), setgid(),
 				   F_GETFD, F_SETFD, FD_CLOEXEC,
 				   access(), pipe(), fork(), close()
-				   dup2(), STDOUT_FILENO, _exit(),
+				   dup2, STDOUT_FILENO, _exit(),
 				   execv(), write(), read(),
 				   close() */
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
@@ -70,7 +69,7 @@
 #define PDIR "/lib/mandos/plugins.d"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
-const char *argp_program_version = "plugin-runner " VERSION;
+const char *argp_program_version = "plugin-runner 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 typedef struct plugin{
@@ -701,7 +700,6 @@
       
       const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
 					   ".dpkg-old",
-					   ".dpkg-bak",
 					   ".dpkg-divert", NULL };
       for(const char **pre = bad_prefixes; *pre != NULL; pre++){
 	size_t pre_len = strlen(*pre);
@@ -848,12 +846,12 @@
 	perror("sigaction");
 	_exit(EXIT_FAILURE);
       }
-      ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
+      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
 	perror("sigprocmask");
 	_exit(EXIT_FAILURE);
       }
-      
+
       ret = dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
       if(ret == -1){
 	perror("dup2");
@@ -909,11 +907,12 @@
     if (maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
+    
   }
   
   closedir(dir);
   dir = NULL;
-  
+
   for(plugin *p = plugin_list; p != NULL; p = p->next){
     if(p->pid != 0){
       break;
@@ -924,7 +923,7 @@
       free_plugin_list();
     }
   }
-  
+
   /* Main loop while running plugins exist */
   while(plugin_list){
     fd_set rfds = rfds_all;
@@ -970,10 +969,6 @@
 	    goto fallback;
 	  }
 	  
-	  plugin *next_plugin = proc->next;
-	  free_plugin(proc);
-	  proc = next_plugin;
-	  
 	  /* We are done modifying process list, so unblock signal */
 	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
 			     NULL);
@@ -987,11 +982,14 @@
 	    break;
 	  }
 	  
+	  plugin *next_plugin = proc->next;
+	  free_plugin(proc);
+	  proc = next_plugin;
 	  continue;
 	}
 	
 	/* This process exited nicely, so print its buffer */
-	
+
 	bool bret = print_out_password(proc->buffer,
 				       proc->buffer_length);
 	if(not bret){
@@ -1063,7 +1061,7 @@
     perror("sigaction");
     exitstatus = EXIT_FAILURE;
   }
-  
+
   if(custom_argv != NULL){
     for(char **arg = custom_argv+1; *arg != NULL; arg++){
       free(*arg);
@@ -1075,7 +1073,7 @@
     closedir(dir);
   }
   
-  /* Kill the processes */
+  /* Free the process list and kill the processes */
   for(plugin *p = plugin_list; p != NULL; p = p->next){
     if(p->pid != 0){
       close(p->fd);
@@ -1094,7 +1092,7 @@
   if(errno != ECHILD){
     perror("wait");
   }
-  
+
   free_plugin_list();
   
   free(plugindir);

=== modified file 'plugin-runner.conf'
--- plugin-runner.conf	2008-10-05 17:38:31 +0000
+++ plugin-runner.conf	2008-09-06 16:31:49 +0000
@@ -1,11 +1,9 @@
 ## This is the configuration file for plugin-runner.  It should be
 ## installed as "/etc/mandos/plugin-runner.conf", which will be copied
 ## to "/conf/conf.d/mandos/plugin-runner.conf" in the initrd.img file.
-##
-## After editing this file, the initrd image file must be updated for
-## the changes to take effect!
 ## 
 ## The default network interface for mandos-client(8mandos) is
 ## "eth0".  Uncomment this line and change it if necessary.
 ## 
+
 #--options-for=mandos-client:--interface=eth0

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2008-09-30 07:23:39 +0000
+++ plugin-runner.xml	2008-09-19 00:00:51 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2008-09-30">
-<!ENTITY % common SYSTEM "common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-19">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- Nwalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>

=== removed file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2008-11-11 16:07:18 +0000
+++ plugins.d/askpass-fifo.c	1970-01-01 00:00:00 +0000
@@ -1,105 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from a FIFO and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* ssize_t */
-#include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
-#include <iso646.h>		/* and */
-#include <errno.h>		/* errno, EEXIST */
-#include <stdio.h>		/* perror() */
-#include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(), 
-				   realloc(), EXIT_SUCCESS */
-#include <fcntl.h>		/* open(), O_RDONLY */
-#include <unistd.h>		/* read(), close(), write(),
-				   STDOUT_FILENO */
-
-
-int main(__attribute__((unused))int argc,
-	 __attribute__((unused))char **argv){
-  int ret = 0;
-  ssize_t sret;
-  
-  /* Create FIFO */
-  const char passfifo[] = "/lib/cryptsetup/passfifo";
-  ret = TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
-  if(ret == -1 and errno != EEXIST){
-    perror("mkfifo");
-    return EXIT_FAILURE;
-  }
-  
-  /* Open FIFO */
-  int fifo_fd = TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
-  if(fifo_fd == -1){
-    perror("open");
-    return EXIT_FAILURE;
-  }
-  
-  /* Read from FIFO */
-  char *buf = NULL;
-  size_t buf_len = 0;
-  {
-    size_t buf_allocated = 0;
-    const size_t blocksize = 1024;
-    do{
-      if(buf_len + blocksize > buf_allocated){
-	char *tmp = realloc(buf, buf_allocated + blocksize);
-	if(tmp == NULL){
-	  perror("realloc");
-	  free(buf);
-	  return EXIT_FAILURE;
-	}
-	buf = tmp;
-	buf_allocated += blocksize;
-      }
-      sret = TEMP_FAILURE_RETRY(read(fifo_fd, buf + buf_len,
-				     buf_allocated - buf_len));
-      if(sret == -1){
-	perror("read");
-	free(buf);
-	return EXIT_FAILURE;
-      }
-      buf_len += (size_t)sret;
-    }while(sret != 0);
-  }
-  
-  /* Close FIFO */
-  TEMP_FAILURE_RETRY(close(fifo_fd));
-  
-  /* Print password to stdout */
-  size_t written = 0;
-  while(written < buf_len){
-    sret = TEMP_FAILURE_RETRY(write(STDOUT_FILENO, buf + written,
-				    buf_len - written));
-    if(sret == -1){
-      perror("write");
-      free(buf);
-      return EXIT_FAILURE;
-    }
-    written += (size_t)sret;
-  }
-  free(buf);
-  
-  return EXIT_SUCCESS;
-}

=== removed file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2008-10-04 20:09:53 +0000
+++ plugins.d/askpass-fifo.xml	1970-01-01 00:00:00 +0000
@@ -1,161 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to get a password from a
-    FIFO.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program reads a password from a <acronym>FIFO</acronym> and
-      outputs it to standard output.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      This program is meant to be imitate a feature of the
-      <command>askpass</command> program, so that programs written to
-      interface with it can keep working under the
-      <application>Mandos</application> system.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/lib/cryptsetup/passfifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> where this program
-	    will read the password.  If it does not exist, it will be
-	    created.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      The only thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>fifo</refentrytitle>
-      <manvolnum>7</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2008-11-11 16:07:18 +0000
+++ plugins.d/mandos-client.c	2008-09-07 01:44:44 +0000
@@ -9,8 +9,7 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ * Copyright © 2007-2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -102,13 +101,17 @@
 
 #define BUFFER_SIZE 256
 
+/*
+  #define PATHDIR "/conf/conf.d/mandos"
+*/
+
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
-const char *argp_program_version = "mandos-client " VERSION;
+const char *argp_program_version = "mandos-client 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 /* Used for passing in values through the Avahi callback functions */

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2008-10-04 01:55:56 +0000
+++ plugins.d/mandos-client.xml	2008-09-12 19:12:40 +0000
@@ -1,18 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2008-10-03">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-12">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
   <refentryinfo>
     <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
+    <!-- Nwalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -344,7 +343,7 @@
     </para>
   </refsect1>
   
-  <refsect1 id="files">
+  <refsect1 id="file">
     <title>FILES</title>
     <variablelist>
       <varlistentry>
@@ -450,11 +449,11 @@
       The only remaining weak point is that someone with physical
       access to the client hard drive might turn off the client
       computer, read the OpenPGP keys directly from the hard drive,
-      and communicate with the server.  To safeguard against this, the
-      server is supposed to notice the client disappearing and stop
-      giving out the encrypted data.  Therefore, it is important to
-      set the timeout and checker interval values tightly on the
-      server.  See <citerefentry><refentrytitle
+      and communicate with the server.  The defense against this is
+      that the server is supposed to notice the client disappearing
+      and will stop giving out the encrypted data.  Therefore, it is
+      important to set the timeout and checker interval values tightly
+      on the server.  See <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>.
     </para>
     <para>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2008-11-11 16:07:18 +0000
+++ plugins.d/password-prompt.c	2008-09-07 01:44:44 +0000
@@ -1,9 +1,8 @@
 /*  -*- coding: utf-8 -*- */
 /*
  * Passprompt - Read a password from the terminal and print it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
+ *
+ * Copyright © 2007-2008 Teddy Hogeborn & Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -53,7 +52,7 @@
 
 volatile bool quit_now = false;
 bool debug = false;
-const char *argp_program_version = "password-prompt " VERSION;
+const char *argp_program_version = "password-prompt 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 static void termination_handler(__attribute__((unused))int signum){

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2008-10-04 01:55:56 +0000
+++ plugins.d/password-prompt.xml	2008-09-06 16:31:49 +0000
@@ -1,10 +1,9 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
+<!ENTITY TIMESTAMP "2008-09-06">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -12,7 +11,7 @@
     <title>Mandos Manual</title>
     <!-- NWalsh’s docbook scripts use this to generate the footer: -->
     <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
+    <productnumber>&VERSION;</productnumber>
     <date>&TIMESTAMP;</date>
     <authorgroup>
       <author>
@@ -84,14 +83,12 @@
     <title>DESCRIPTION</title>
     <para>
       All <command>&COMMANDNAME;</command> does is prompt for a
-      password and output any given password to standard output.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
+      password and output any given password to standard output.  This
+      is not very useful on its own.  This program is really meant to
+      run as a plugin in the <application>Mandos</application>
+      client-side system, where it is used as a fallback and
+      alternative to retrieving passwords from a <application
+      >Mandos</application> server.
     </para>
     <para>
       This program is little more than a <citerefentry><refentrytitle

=== removed file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2008-11-11 16:07:18 +0000
+++ plugins.d/splashy.c	1970-01-01 00:00:00 +0000
@@ -1,291 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from splashy and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _GNU_SOURCE		/* asprintf() */
-#include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction,
-				   SIG_IGN, kill(), SIGKILL */
-#include <stddef.h>		/* NULL */
-#include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf(), perror() */
-#include <stdlib.h>		/* EXIT_FAILURE, free(), strtoul(),
-				   EXIT_SUCCESS */
-#include <sys/types.h>		/* pid_t, DIR, struct dirent,
-				   ssize_t */
-#include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
-#include <iso646.h>		/* not, or, and */
-#include <unistd.h>		/* readlink(), fork(), execl(),
-				   sleep(), dup2() STDERR_FILENO,
-				   STDOUT_FILENO, _exit() */
-#include <string.h>		/* memcmp() */
-#include <errno.h>		/* errno */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS() */
-
-sig_atomic_t interrupted_by_signal = 0;
-
-static void termination_handler(__attribute__((unused))int signum){
-  interrupted_by_signal = 1;
-}
-
-int main(__attribute__((unused))int argc,
-	 __attribute__((unused))char **argv){
-  int ret = 0;
-  
-  /* Create prompt string */
-  char *prompt = NULL;
-  {
-    const char *const cryptsource = getenv("cryptsource");
-    const char *const crypttarget = getenv("crypttarget");
-    const char *const prompt_start = "getpass "
-      "Enter passphrase to unlock the disk";
-    
-    if(cryptsource == NULL){
-      if(crypttarget == NULL){
-	ret = asprintf(&prompt, "%s: ", prompt_start);
-      } else {
-	ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		       crypttarget);
-      }
-    } else {
-      if(crypttarget == NULL){
-	ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
-      } else {
-	ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		       cryptsource, crypttarget);
-      }
-    }
-    if(ret == -1){
-      return EXIT_FAILURE;
-    }
-  }
-  
-  /* Find splashy process */
-  pid_t splashy_pid = 0;
-  {
-    const char splashy_name[] = "/sbin/splashy";
-    DIR *proc_dir = opendir("/proc");
-    if(proc_dir == NULL){
-      free(prompt);
-      perror("opendir");
-      return EXIT_FAILURE;
-    }
-    for(struct dirent *proc_ent = readdir(proc_dir);
-	proc_ent != NULL;
-	proc_ent = readdir(proc_dir)){
-      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
-      if(pid == 0){
-	/* Not a process */
-	continue;
-      }
-      /* Find the executable name by doing readlink() on the
-	 /proc/<pid>/exe link */
-      char exe_target[sizeof(splashy_name)];
-      ssize_t sret;
-      {
-	char *exe_link;
-	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
-	if(ret == -1){
-	  perror("asprintf");
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	
-	/* Check that it refers to a symlink owned by root:root */
-	struct stat exe_stat;
-	ret = lstat(exe_link, &exe_stat);
-	if(ret == -1){
-	  perror("lstat");
-	  free(exe_link);
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	if(not S_ISLNK(exe_stat.st_mode)
-	   or exe_stat.st_uid != 0
-	   or exe_stat.st_gid != 0){
-	  free(exe_link);
-	  continue;
-	}
-	
-	sret = readlink(exe_link, exe_target, sizeof(exe_target));
-	free(exe_link);
-      }
-      if((sret == ((ssize_t)sizeof(exe_target)-1))
-	 and (memcmp(splashy_name, exe_target,
-		     sizeof(exe_target)-1) == 0)){
-	splashy_pid = pid;
-	break;
-      }
-    }
-    closedir(proc_dir);
-  }
-  if(splashy_pid == 0){
-    free(prompt);
-    return EXIT_FAILURE;
-  }
-  
-  /* Set up the signal handler */
-  {
-    struct sigaction old_action,
-      new_action = { .sa_handler = termination_handler,
-		     .sa_flags = 0 };
-    sigemptyset(&new_action.sa_mask);
-    sigaddset(&new_action.sa_mask, SIGINT);
-    sigaddset(&new_action.sa_mask, SIGHUP);
-    sigaddset(&new_action.sa_mask, SIGTERM);
-    ret = sigaction(SIGINT, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGINT, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-    ret = sigaction(SIGHUP, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGHUP, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-    ret = sigaction(SIGTERM, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGTERM, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-  }
-  
-  /* Fork off the splashy command to prompt for password */
-  pid_t splashy_command_pid = 0;
-  if(not interrupted_by_signal){
-    splashy_command_pid = fork();
-    if(splashy_command_pid == -1){
-      if(not interrupted_by_signal){
-	perror("fork");
-      }
-      return EXIT_FAILURE;
-    }
-    /* Child */
-    if(splashy_command_pid == 0){
-      const char splashy_command[] = "/sbin/splashy_update";
-      ret = execl(splashy_command, splashy_command, prompt,
-		  (char *)NULL);
-      if(not interrupted_by_signal){
-	perror("execl");
-      }
-      free(prompt);
-      _exit(EXIT_FAILURE);
-    }
-  }
-  
-  /* Parent */
-  free(prompt);
-  
-  /* Wait for command to complete */
-  if(not interrupted_by_signal and splashy_command_pid != 0){
-    int status;
-    ret = waitpid(splashy_command_pid, &status, 0);
-    if(ret == -1){
-      if(errno != EINTR){
-	perror("waitpid");
-      }
-      if(errno == ECHILD){
-	splashy_command_pid = 0;
-      }
-    } else {
-      /* The child process has exited */
-      splashy_command_pid = 0;
-      if(not interrupted_by_signal and WIFEXITED(status)
-	 and WEXITSTATUS(status)==0){
-	return EXIT_SUCCESS;
-      }
-    }
-  }
-  kill(splashy_pid, SIGTERM);
-  if(interrupted_by_signal and splashy_command_pid != 0){
-    kill(splashy_command_pid, SIGTERM);
-  }
-  sleep(2);
-  while(kill(splashy_pid, 0) == 0){
-    kill(splashy_pid, SIGKILL);
-    sleep(1);
-  }
-  pid_t new_splashy_pid = fork();
-  if(new_splashy_pid == 0){
-    /* Child; will become new splashy process */
-    
-    /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (mandos) */
-    ret = setuid(geteuid());
-    if(ret == -1){
-      perror("setuid");
-    }
-    
-    setsid();
-    ret = chdir("/");
-/*     if(fork() != 0){ */
-/*       _exit(EXIT_SUCCESS); */
-/*     } */
-    ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
-    if(ret == -1){
-      perror("dup2");
-      _exit(EXIT_FAILURE);
-    }
-    
-    execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
-    if(not interrupted_by_signal){
-      perror("execl");
-    }
-    _exit(EXIT_FAILURE);
-  }
-  
-  return EXIT_FAILURE;
-}

=== removed file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2008-10-04 03:11:39 +0000
+++ plugins.d/splashy.xml	1970-01-01 00:00:00 +0000
@@ -1,282 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to use splashy to get a
-    password.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program prompts for a password using <citerefentry>
-      <refentrytitle>splashy_update</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and outputs any given
-      password to standard output.  If no <citerefentry><refentrytitle
-      >splashy</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      process can be found, this program will immediately exit with an
-      exit code indicating failure.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      If this program is killed (presumably by
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry> because some other
-      plugin provided the password), it cannot tell <citerefentry>
-      <refentrytitle>splashy</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> to abort requesting a password, because
-      <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> does not support this.
-      Therefore, this program will then <emphasis>kill</emphasis> the
-      running <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> process and start a
-      <emphasis>new</emphasis> one, using <quote><literal
-      >boot</literal></quote> as the only argument.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="environment">
-    <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
-	<listitem>
-	  <para>
-	    If set, these environment variables will be assumed to
-	    contain the source device name and the target device
-	    mapper name, respectively, and will be shown as part of
-	    the prompt.
-	</para>
-	<para>
-	  These variables will normally be inherited from
-	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
-	</para>
-	<para>
-	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/sbin/splashy_update</filename></term>
-	<listitem>
-	  <para>
-	    This is the command run to retrieve a password from
-	    <citerefentry><refentrytitle>splashy</refentrytitle>
-	    <manvolnum>8</manvolnum></citerefentry>.  See
-	    <citerefentry><refentrytitle
-	    >splashy_update</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/proc</filename></term>
-	<listitem>
-	  <para>
-	    To find the running <citerefentry><refentrytitle
-	    >splashy</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>, this directory will be searched for
-	    numeric entries which will be assumed to be directories.
-	    In all those directories, the <filename>exe</filename>
-	    entry will be used to determine the name of the running
-	    binary and the effective user and group
-	    <abbrev>ID</abbrev> of the process.  See <citerefentry>
-	    <refentrytitle>proc</refentrytitle><manvolnum
-	    >5</manvolnum></citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/sbin/splashy</filename></term>
-	<listitem>
-	  <para>
-	    This is the name of the binary which will be searched for
-	    in the process list.  See <citerefentry><refentrytitle
-	    >splashy</refentrytitle><manvolnum>8</manvolnum>
-	  </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      Killing <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and starting a new one
-      is ugly, but necessary as long as it does not support aborting a
-      password request.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      If this program is killed by a signal, it will kill the process
-      <abbrev>ID</abbrev> which at the start of this program was
-      determined to run <citerefentry><refentrytitle
-      >splashy</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      as root (see also <xref linkend="files"/>).  There is a very
-      slight risk that, in the time between those events, that process
-      <abbrev>ID</abbrev> was freed and then taken up by another
-      process; the wrong process would then be killed.  Now, this
-      program can only be killed by the user who started it; see
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  This program
-      should therefore be started by a completely separate
-      non-privileged user, and no other programs should be allowed to
-      run as that special user.  This means that it is not recommended
-      to use the user "nobody" to start this program, as other
-      possibly less trusted programs could be running as "nobody", and
-      they would then be able to kill this program, triggering the
-      killing of the process <abbrev>ID</abbrev> which may or may not
-      be <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      The only other thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>proc</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>splashy</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>splashy_update</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

=== added file 'plugins.d/usplash'
--- plugins.d/usplash	1970-01-01 00:00:00 +0000
+++ plugins.d/usplash	2008-08-14 02:24:59 +0000
@@ -0,0 +1,42 @@
+#!/bin/sh -e
+
+# If not on a tty, then get rid of possibly disrupting stderr output
+if ! tty -s; then
+    exec 2>/dev/null
+fi
+
+test -x /sbin/usplash
+
+usplash="`pidof usplash -o $$`"
+test -n "$usplash"
+
+# We get some variables from cryptsetup:
+# $cryptsource	the device node, like "/dev/sda3"
+# $crypttarget	the device mapper name, like "sda3_crypt".
+
+prompt="Enter passphrase to unlock"
+if [ -n "$crypttarget" ]; then
+    prompt="$prompt the disk $crypttarget"
+fi
+if [ -n "$cryptsource" ]; then
+    prompt="$prompt ($cryptsource)"
+fi
+
+splash_input_password(){
+    test -p /dev/.initramfs/usplash_outfifo || return 1
+    /sbin/usplash_write "INPUTQUIET $1" || return 1
+    cat /dev/.initramfs/usplash_outfifo 2> /dev/null || return 1
+}
+
+# Usplash keeps waiting for input even if some other plugin provided
+# the password, so we must kill it
+trap "kill -TERM $usplash; sleep 2; kill -KILL $usplash; 
+	kill -TERM $$" TERM HUP
+
+password="`splash_input_password \"$prompt: \" password`"
+
+trap - TERM
+
+/sbin/usplash_write "TIMEOUT 15"
+
+echo -n "$password"

=== removed file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2008-11-11 16:07:18 +0000
+++ plugins.d/usplash.c	1970-01-01 00:00:00 +0000
@@ -1,521 +0,0 @@
-/*  -*- coding: utf-8 -*- */
-/*
- * Passprompt - Read a password from usplash and output it
- * 
- * Copyright © 2008 Teddy Hogeborn
- * Copyright © 2008 Björn Påhlsson
- * 
- * This program is free software: you can redistribute it and/or
- * modify it under the terms of the GNU General Public License as
- * published by the Free Software Foundation, either version 3 of the
- * License, or (at your option) any later version.
- * 
- * This program is distributed in the hope that it will be useful, but
- * WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
- * General Public License for more details.
- * 
- * You should have received a copy of the GNU General Public License
- * along with this program.  If not, see
- * <http://www.gnu.org/licenses/>.
- * 
- * Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
- * <https://www.fukt.bsnet.se/~teddy/>.
- */
-
-#define _GNU_SOURCE		/* asprintf() */
-#include <signal.h>		/* sig_atomic_t, struct sigaction,
-				   sigemptyset(), sigaddset(), SIGINT,
-				   SIGHUP, SIGTERM, sigaction(),
-				   SIG_IGN, kill(), SIGKILL */
-#include <stdbool.h>		/* bool, false, true */
-#include <fcntl.h>		/* open(), O_WRONLY, O_RDONLY */
-#include <iso646.h>		/* and, or, not*/
-#include <errno.h>		/* errno, EINTR */
-#include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
-				   dirent */
-#include <stddef.h>		/* NULL */
-#include <string.h>		/* strlen(), memcmp() */
-#include <stdio.h>		/* asprintf(), perror() */
-#include <unistd.h>		/* close(), write(), readlink(),
-				   read(), STDOUT_FILENO, sleep(),
-				   fork(), setuid(), geteuid(),
-				   setsid(), chdir(), dup2(),
-				   STDERR_FILENO, execv() */
-#include <stdlib.h>		/* free(), EXIT_FAILURE, strtoul(),
-				   realloc(), EXIT_SUCCESS, malloc(),
-				   _exit() */
-#include <stdlib.h>		/* getenv() */
-#include <dirent.h>		/* opendir(), readdir(), closedir() */
-#include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
-
-sig_atomic_t interrupted_by_signal = 0;
-
-static void termination_handler(__attribute__((unused))int signum){
-  interrupted_by_signal = 1;
-}
-
-static bool usplash_write(const char *cmd, const char *arg){
-  /* 
-   * usplash_write("TIMEOUT", "15") will write "TIMEOUT 15\0"
-   * usplash_write("PULSATE", NULL) will write "PULSATE\0"
-   * SEE ALSO
-   *         usplash_write(8)
-   */
-  int ret;
-  int fifo_fd;
-  do{
-    fifo_fd = open("/dev/.initramfs/usplash_fifo", O_WRONLY);
-    if(fifo_fd == -1 and (errno != EINTR or interrupted_by_signal)){
-      return false;
-    }
-  }while(fifo_fd == -1);
-  
-  const char *cmd_line;
-  size_t cmd_line_len;
-  char *cmd_line_alloc = NULL;
-  if(arg == NULL){
-    cmd_line = cmd;
-    cmd_line_len = strlen(cmd);
-  }else{
-    do{
-      ret = asprintf(&cmd_line_alloc, "%s %s", cmd, arg);
-      if(ret == -1 and (errno != EINTR or interrupted_by_signal)){
-	int e = errno;
-	close(fifo_fd);
-	errno = e;
-	return false;
-      }
-    }while(ret == -1);
-    cmd_line = cmd_line_alloc;
-    cmd_line_len = (size_t)ret + 1;
-  }
-  
-  size_t written = 0;
-  while(not interrupted_by_signal and written < cmd_line_len){
-    ret = write(fifo_fd, cmd_line + written,
-		cmd_line_len - written);
-    if(ret == -1){
-      if(errno != EINTR or interrupted_by_signal){
-	int e = errno;
-	close(fifo_fd);
-	free(cmd_line_alloc);
-	errno = e;
-	return false;
-      } else {
-	continue;
-      }
-    }
-    written += (size_t)ret;
-  }
-  free(cmd_line_alloc);
-  do{
-    ret = close(fifo_fd);
-    if(ret == -1 and (errno != EINTR or interrupted_by_signal)){
-      return false;
-    }
-  }while(ret == -1);
-  if(interrupted_by_signal){
-    return false;
-  }
-  return true;
-}
-
-int main(__attribute__((unused))int argc,
-	 __attribute__((unused))char **argv){
-  int ret = 0;
-  ssize_t sret;
-  bool an_error_occured = false;
-  
-  /* Create prompt string */
-  char *prompt = NULL;
-  {
-    const char *const cryptsource = getenv("cryptsource");
-    const char *const crypttarget = getenv("crypttarget");
-    const char prompt_start[] = "Enter passphrase to unlock the disk";
-    
-    if(cryptsource == NULL){
-      if(crypttarget == NULL){
-	ret = asprintf(&prompt, "%s: ", prompt_start);
-      } else {
-	ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		       crypttarget);
-      }
-    } else {
-      if(crypttarget == NULL){
-	ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
-      } else {
-	ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		       cryptsource, crypttarget);
-      }
-    }
-    if(ret == -1){
-      return EXIT_FAILURE;
-    }
-  }
-  
-  /* Find usplash process */
-  pid_t usplash_pid = 0;
-  char *cmdline = NULL;
-  size_t cmdline_len = 0;
-  const char usplash_name[] = "/sbin/usplash";
-  {
-    DIR *proc_dir = opendir("/proc");
-    if(proc_dir == NULL){
-      free(prompt);
-      perror("opendir");
-      return EXIT_FAILURE;
-    }
-    for(struct dirent *proc_ent = readdir(proc_dir);
-	proc_ent != NULL;
-	proc_ent = readdir(proc_dir)){
-      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
-      if(pid == 0){
-	/* Not a process */
-	continue;
-      }
-      /* Find the executable name by doing readlink() on the
-	 /proc/<pid>/exe link */
-      char exe_target[sizeof(usplash_name)];
-      {
-	/* create file name string */
-	char *exe_link;
-	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
-	if(ret == -1){
-	  perror("asprintf");
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	
-	/* Check that it refers to a symlink owned by root:root */
-	struct stat exe_stat;
-	ret = lstat(exe_link, &exe_stat);
-	if(ret == -1){
-	  perror("lstat");
-	  free(exe_link);
-	  free(prompt);
-	  closedir(proc_dir);
-	  return EXIT_FAILURE;
-	}
-	if(not S_ISLNK(exe_stat.st_mode)
-	   or exe_stat.st_uid != 0
-	   or exe_stat.st_gid != 0){
-	  free(exe_link);
-	  continue;
-	}
-	
-	sret = readlink(exe_link, exe_target, sizeof(exe_target));
-	free(exe_link);
-	if(sret == -1){
-	  continue;
-	}
-      }
-      if((sret == ((ssize_t)sizeof(exe_target)-1))
-	 and (memcmp(usplash_name, exe_target,
-		     sizeof(exe_target)-1) == 0)){
-	usplash_pid = pid;
-	/* Read and save the command line of usplash in "cmdline" */
-	{
-	  /* Open /proc/<pid>/cmdline  */
-	  int cl_fd;
-	  {
-	    char *cmdline_filename;
-	    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
-			   proc_ent->d_name);
-	    if(ret == -1){
-	      perror("asprintf");
-	      free(prompt);
-	      closedir(proc_dir);
-	      return EXIT_FAILURE;
-	    }
-	    cl_fd = open(cmdline_filename, O_RDONLY);
-	    if(cl_fd == -1){
-	      perror("open");
-	      free(cmdline_filename);
-	      free(prompt);
-	      closedir(proc_dir);
-	      return EXIT_FAILURE;
-	    }
-	    free(cmdline_filename);
-	  }
-	  size_t cmdline_allocated = 0;
-	  char *tmp;
-	  const size_t blocksize = 1024;
-	  do{
-	    if(cmdline_len + blocksize > cmdline_allocated){
-	      tmp = realloc(cmdline, cmdline_allocated + blocksize);
-	      if(tmp == NULL){
-		perror("realloc");
-		free(cmdline);
-		free(prompt);
-		closedir(proc_dir);
-		return EXIT_FAILURE;
-	      }
-	      cmdline = tmp;
-	      cmdline_allocated += blocksize;
-	    }
-	    sret = read(cl_fd, cmdline + cmdline_len,
-			cmdline_allocated - cmdline_len);
-	    if(sret == -1){
-	      perror("read");
-	      free(cmdline);
-	      free(prompt);
-	      closedir(proc_dir);
-	      return EXIT_FAILURE;
-	    }
-	    cmdline_len += (size_t)sret;
-	  } while(sret != 0);
-	  close(cl_fd);
-	}
-	break;
-      }
-    }
-    closedir(proc_dir);
-  }
-  if(usplash_pid == 0){
-    free(prompt);
-    return EXIT_FAILURE;
-  }
-  
-  /* Set up the signal handler */
-  {
-    struct sigaction old_action,
-      new_action = { .sa_handler = termination_handler,
-		     .sa_flags = 0 };
-    sigemptyset(&new_action.sa_mask);
-    sigaddset(&new_action.sa_mask, SIGINT);
-    sigaddset(&new_action.sa_mask, SIGHUP);
-    sigaddset(&new_action.sa_mask, SIGTERM);
-    ret = sigaction(SIGINT, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGINT, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-    ret = sigaction(SIGHUP, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGHUP, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-    ret = sigaction(SIGTERM, NULL, &old_action);
-    if(ret == -1){
-      perror("sigaction");
-      free(prompt);
-      return EXIT_FAILURE;
-    }
-    if(old_action.sa_handler != SIG_IGN){
-      ret = sigaction(SIGTERM, &new_action, NULL);
-      if(ret == -1){
-	perror("sigaction");
-	free(prompt);
-	return EXIT_FAILURE;
-      }
-    }
-  }
-  
-  /* Write command to FIFO */
-  if(not interrupted_by_signal){
-    if(not usplash_write("TIMEOUT", "0")
-       and (errno != EINTR)){
-      perror("usplash_write");
-      an_error_occured = true;
-    }
-  }
-  if(not interrupted_by_signal and not an_error_occured){
-    if(not usplash_write("INPUTQUIET", prompt)
-       and (errno != EINTR)){
-      perror("usplash_write");
-      an_error_occured = true;
-    }
-  }
-  free(prompt);
-  
-  /* This is not really a loop; while() is used to be able to "break"
-     out of it; those breaks are marked "Big" */
-  while(not interrupted_by_signal and not an_error_occured){
-    char *buf = NULL;
-    size_t buf_len = 0;
-    
-    /* Open FIFO */
-    int fifo_fd;
-    do{
-      fifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
-      if(fifo_fd == -1){
-	if(errno != EINTR){
-	  perror("open");
-	  an_error_occured = true;
-	  break;
-	}
-	if(interrupted_by_signal){
-	  break;
-	}
-      }
-    }while(fifo_fd == -1);
-    if(interrupted_by_signal or an_error_occured){
-      break;			/* Big */
-    }
-    
-    /* Read from FIFO */
-    size_t buf_allocated = 0;
-    const size_t blocksize = 1024;
-    do{
-      if(buf_len + blocksize > buf_allocated){
-	char *tmp = realloc(buf, buf_allocated + blocksize);
-	if(tmp == NULL){
-	  perror("realloc");
-	  an_error_occured = true;
-	  break;
-	}
-	buf = tmp;
-	buf_allocated += blocksize;
-      }
-      do{
-	sret = read(fifo_fd, buf + buf_len, buf_allocated - buf_len);
-	if(sret == -1){
-	  if(errno != EINTR){
-	    perror("read");
-	    an_error_occured = true;
-	    break;
-	  }
-	  if(interrupted_by_signal){
-	    break;
-	  }
-	}
-      }while(sret == -1);
-      if(interrupted_by_signal or an_error_occured){
-	break;
-      }
-      
-      buf_len += (size_t)sret;
-    }while(sret != 0);
-    close(fifo_fd);
-    if(interrupted_by_signal or an_error_occured){
-      break;			/* Big */
-    }
-    
-    if(not usplash_write("TIMEOUT", "15")
-       and (errno != EINTR)){
-	perror("usplash_write");
-	an_error_occured = true;
-    }
-    if(interrupted_by_signal or an_error_occured){
-      break;			/* Big */
-    }
-    
-    /* Print password to stdout */
-    size_t written = 0;
-    while(written < buf_len){
-      do{
-	sret = write(STDOUT_FILENO, buf + written, buf_len - written);
-	if(sret == -1){
-	  if(errno != EINTR){
-	    perror("write");
-	    an_error_occured = true;
-	    break;
-	  }
-	  if(interrupted_by_signal){
-	    break;
-	  }
-	}
-      }while(sret == -1);
-      if(interrupted_by_signal or an_error_occured){
-	break;
-      }
-      written += (size_t)sret;
-    }
-    free(buf);
-    if(not interrupted_by_signal and not an_error_occured){
-      free(cmdline);
-      return EXIT_SUCCESS;
-    }
-    break;			/* Big */
-  }				/* end of non-loop while() */
-  
-  /* If we got here, an error or interrupt must have happened */
-  
-  /* Create argc and argv for new usplash*/
-  int cmdline_argc = 0;
-  char **cmdline_argv = malloc(sizeof(char *));
-  {
-    size_t position = 0;
-    while(position < cmdline_len){
-      char **tmp = realloc(cmdline_argv,
-			   (sizeof(char *)
-			    * (size_t)(cmdline_argc + 2)));
-      if(tmp == NULL){
-	perror("realloc");
-	free(cmdline_argv);
-	return EXIT_FAILURE;
-      }
-      cmdline_argv = tmp;
-      cmdline_argv[cmdline_argc] = cmdline + position;
-      cmdline_argc++;
-      position += strlen(cmdline + position) + 1;
-    }
-    cmdline_argv[cmdline_argc] = NULL;
-  }
-  /* Kill old usplash */
-  kill(usplash_pid, SIGTERM);
-  sleep(2);
-  while(kill(usplash_pid, 0) == 0){
-    kill(usplash_pid, SIGKILL);
-    sleep(1);
-  }
-  pid_t new_usplash_pid = fork();
-  if(new_usplash_pid == 0){
-    /* Child; will become new usplash process */
-    
-    /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (mandos) */
-    ret = setuid(geteuid());
-    if(ret == -1){
-      perror("setuid");
-    }
-    
-    setsid();
-    ret = chdir("/");
-/*     if(fork() != 0){ */
-/*       _exit(EXIT_SUCCESS); */
-/*     } */
-    ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
-    if(ret == -1){
-      perror("dup2");
-      _exit(EXIT_FAILURE);
-    }
-    
-    execv(usplash_name, cmdline_argv);
-    if(not interrupted_by_signal){
-      perror("execv");
-    }
-    free(cmdline);
-    free(cmdline_argv);
-    _exit(EXIT_FAILURE);
-  }
-  free(cmdline);
-  free(cmdline_argv);
-  sleep(2);
-  if(not usplash_write("PULSATE", NULL)
-     and (errno != EINTR)){
-    perror("usplash_write");
-  }
-  
-  return EXIT_FAILURE;
-}

=== removed file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2008-10-04 03:11:39 +0000
+++ plugins.d/usplash.xml	1970-01-01 00:00:00 +0000
@@ -1,296 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
-	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2008-10-04">
-<!ENTITY % common SYSTEM "../common.ent">
-%common;
-]>
-
-<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
-  <refentryinfo>
-    <title>Mandos Manual</title>
-    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
-    <productname>Mandos</productname>
-    <productnumber>&version;</productnumber>
-    <date>&TIMESTAMP;</date>
-    <authorgroup>
-      <author>
-	<firstname>Björn</firstname>
-	<surname>Påhlsson</surname>
-	<address>
-	  <email>belorn@fukt.bsnet.se</email>
-	</address>
-      </author>
-      <author>
-	<firstname>Teddy</firstname>
-	<surname>Hogeborn</surname>
-	<address>
-	  <email>teddy@fukt.bsnet.se</email>
-	</address>
-      </author>
-    </authorgroup>
-    <copyright>
-      <year>2008</year>
-      <holder>Teddy Hogeborn</holder>
-      <holder>Björn Påhlsson</holder>
-    </copyright>
-    <xi:include href="../legalnotice.xml"/>
-  </refentryinfo>
-  
-  <refmeta>
-    <refentrytitle>&COMMANDNAME;</refentrytitle>
-    <manvolnum>8mandos</manvolnum>
-  </refmeta>
-  
-  <refnamediv>
-    <refname><command>&COMMANDNAME;</command></refname>
-    <refpurpose>Mandos plugin to use usplash to get a
-    password.</refpurpose>
-  </refnamediv>
-  
-  <refsynopsisdiv>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-    </cmdsynopsis>
-  </refsynopsisdiv>
-  
-  <refsect1 id="description">
-    <title>DESCRIPTION</title>
-    <para>
-      This program prompts for a password using <citerefentry>
-      <refentrytitle>usplash</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> and outputs any given password to standard
-      output.  If no <citerefentry><refentrytitle
-      >usplash</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      process can be found, this program will immediately exit with an
-      exit code indicating failure.
-    </para>
-    <para>
-      This program is not very useful on its own.  This program is
-      really meant to run as a plugin in the <application
-      >Mandos</application> client-side system, where it is used as a
-      fallback and alternative to retrieving passwords from a
-      <application >Mandos</application> server.
-    </para>
-    <para>
-      If this program is killed (presumably by
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry> because some other
-      plugin provided the password), it cannot tell <citerefentry>
-      <refentrytitle>usplash</refentrytitle><manvolnum>8</manvolnum>
-      </citerefentry> to abort requesting a password, because
-      <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> does not support this.
-      Therefore, this program will then <emphasis>kill</emphasis> the
-      running <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> process and start a
-      <emphasis>new</emphasis> one using the same command line
-      arguments as the old one was using.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="options">
-    <title>OPTIONS</title>
-    <para>
-      This program takes no options.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="exit_status">
-    <title>EXIT STATUS</title>
-    <para>
-      If exit status is 0, the output from the program is the password
-      as it was read.  Otherwise, if exit status is other than 0, the
-      program was interrupted or encountered an error, and any output
-      so far could be corrupt and/or truncated, and should therefore
-      be ignored.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="environment">
-    <title>ENVIRONMENT</title>
-    <variablelist>
-      <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
-	<listitem>
-	  <para>
-	    If set, these environment variables will be assumed to
-	    contain the source device name and the target device
-	    mapper name, respectively, and will be shown as part of
-	    the prompt.
-	</para>
-	<para>
-	  These variables will normally be inherited from
-	  <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-	  <manvolnum>8mandos</manvolnum></citerefentry>, which will
-	  normally have inherited them from
-	  <filename>/scripts/local-top/cryptroot</filename> in the
-	  initial <acronym>RAM</acronym> disk environment, which will
-	  have set them from parsing kernel arguments and
-	  <filename>/conf/conf.d/cryptroot</filename> (also in the
-	  initial RAM disk environment), which in turn will have been
-	  created when the initial RAM disk image was created by
-	  <filename
-	  >/usr/share/initramfs-tools/hooks/cryptroot</filename>, by
-	  extracting the information of the root file system from
-	  <filename >/etc/crypttab</filename>.
-	</para>
-	<para>
-	  This behavior is meant to exactly mirror the behavior of
-	  <command>askpass</command>, the default password prompter.
-	</para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="files">
-    <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/dev/.initramfs/usplash_fifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> to where this program
-	    will write the commands for <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.  See <citerefentry><refentrytitle
-	    >fifo</refentrytitle><manvolnum>7</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/dev/.initramfs/usplash_outfifo</filename></term>
-	<listitem>
-	  <para>
-	    This is the <acronym>FIFO</acronym> where this program
-	    will read the password from <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.  See <citerefentry><refentrytitle
-	    >fifo</refentrytitle><manvolnum>7</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/proc</filename></term>
-	<listitem>
-	  <para>
-	    To find the running <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>, this directory will be searched for
-	    numeric entries which will be assumed to be directories.
-	    In all those directories, the <filename>exe</filename> and
-	    <filename>cmdline</filename> entries will be used to
-	    determine the name of the running binary, effective user
-	    and group <abbrev>ID</abbrev>, and the command line
-	    arguments.  See <citerefentry><refentrytitle
-	    >proc</refentrytitle><manvolnum>5</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/sbin/usplash</filename></term>
-	<listitem>
-	  <para>
-	    This is the name of the binary which will be searched for
-	    in the process list.  See <citerefentry><refentrytitle
-	    >usplash</refentrytitle><manvolnum>8</manvolnum>
-	    </citerefentry>.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      Killing <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry> and starting a new one
-      is ugly, but necessary as long as it does not support aborting a
-      password request.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="example">
-    <title>EXAMPLE</title>
-    <para>
-      Note that normally, this program will not be invoked directly,
-      but instead started by the Mandos <citerefentry><refentrytitle
-      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
-      </citerefentry>.
-    </para>
-    <informalexample>
-      <para>
-	This program takes no options.
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-  </refsect1>
-  
-  <refsect1 id="security">
-    <title>SECURITY</title>
-    <para>
-      If this program is killed by a signal, it will kill the process
-      <abbrev>ID</abbrev> which at the start of this program was
-      determined to run <citerefentry><refentrytitle
-      >usplash</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      as root (see also <xref linkend="files"/>).  There is a very
-      slight risk that, in the time between those events, that process
-      <abbrev>ID</abbrev> was freed and then taken up by another
-      process; the wrong process would then be killed.  Now, this
-      program can only be killed by the user who started it; see
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  This program
-      should therefore be started by a completely separate
-      non-privileged user, and no other programs should be allowed to
-      run as that special user.  This means that it is not recommended
-      to use the user "nobody" to start this program, as other
-      possibly less trusted programs could be running as "nobody", and
-      they would then be able to kill this program, triggering the
-      killing of the process <abbrev>ID</abbrev> which may or may not
-      be <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      The only other thing that could be considered worthy of note is
-      this:  This program is meant to be run by <citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle><manvolnum
-      >8mandos</manvolnum></citerefentry>, and will, when run
-      standalone, outside, in a normal environment, immediately output
-      on its standard output any presumably secret password it just
-      received.  Therefore, when running this program standalone
-      (which should never normally be done), take care not to type in
-      any real secret password by force of habit, since it would then
-      immediately be shown as output.
-    </para>
-  </refsect1>
-  
-  <refsect1 id="see_also">
-    <title>SEE ALSO</title>
-    <para>
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>fifo</refentrytitle>
-      <manvolnum>7</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>proc</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>usplash</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>
-    </para>
-  </refsect1>
-</refentry>
-<!-- Local Variables: -->
-<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
-<!-- time-stamp-end: "[\"']>" -->
-<!-- time-stamp-format: "%:y-%02m-%02d" -->
-<!-- End: -->

